	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\lib\_fmlt.c' 13 0 15 19 4 31
;1 //----- _fmlt.c ----- 07/13/10 -----(01/09/08)-----
;2 
;3 //-------------------------------------------------------------------------
;4 //  A faster (but less precise) version of the "internal" __fmlt() function
;5 //  for multiplying 2 IEEE 32-bit float point numbers.
;6 //-------------------------------------------------------------------------
;7 //  Version log (most recent first):
;8 //
;9 //
;10 //  2010-07-13 - Mark Davis
;11 //               - Modified version of my fmult() function that serves as a
;12 //                 direct replacement for Softool's internal __fmlt() (i.e.
;13 //                 ALL floating point multiplications will be done using th
;14 //                 version rather than the Softools one, without having to 
;15 //                 it explicitly).  This version is about 2.5 times as fast
;16 //                 the Softools version.
;17 //
;18 //  2008-01-09 - Mark Davis
;19 //               - Completed original version of fmult(), a faster alternat
;20 //                 to Softools' more accurate but slower floating point
;21 //                 multiply.  Tests show that this version is about 2.5 tim
;22 //                 as fast as the Softools version (on an RCM3200 about 17-
;23 //                 ms vs around 44 ms for the Softools version).  The
;24 //                 compromise is that this version can have errors in the l
;25 //                 2 or 3 bits.
;26 //
;27 //-------------------------------------------------------------------------
;28 
;29 //-------------------------------------------------------------------------
;30 #asm
	.debug	# 31
.cseg

	.debug	# 35
__fmlt::   

	.debug	# 38
.COMMENT ~

	.debug	# 39
---------- stack usage ----------

	.debug	# 40
ix-13: manRes (ls byte)  working 32-bit result mantissa

	.debug	# 41
ix-12: manRes

	.debug	# 42
ix-11: manRes

	.debug	# 43
ix-10: manRes (ms byte)

	.debug	# 45
ix-9:  man2A (ls byte)

	.debug	# 46
ix-8:  man2A (ms byte)

	.debug	# 48
ix-7:  man1A (ls byte)

	.debug	# 49
ix-6:  man1A (ms byte)

	.debug	# 51
ix-5:  expRes (result exponent)

	.debug	# 53
ix-4:  f2 (ls byte)

	.debug	# 54
ix-3:  f2

	.debug	# 55
ix-2:  f2

	.debug	# 56
ix-1:  f2 (ms byte)

	.debug	# 58
ix+0:  saved IX (LSB)

	.debug	# 59
ix+1:  saved IX (MSB)

	.debug	# 61
ix+2:  return addr (LSB)

	.debug	# 62
ix+3:  return addr (MSB)

	.debug	# 64
ix+4:  f1 (ls byte)

	.debug	# 65
ix+5:  f1

	.debug	# 66
ix+6:  f1

	.debug	# 67
ix+7:  f1 (ms byte)

	.debug	# 68
--------------------------------

	.debug	# 69
~

	.debug	# 72
.manRes     equ   -13     

	.debug	# 73
.man2A      equ    -9     

	.debug	# 74
.man1A      equ    -7     

	.debug	# 75
.expRes     equ    -5     

	.debug	# 76
.f2         equ    -4     

	.debug	# 77
.f1         equ     4     

	.debug	# 80
push    ix                 

	.debug	# 82
ld      ix,0               

	.debug	# 83
add     ix,sp              

	.debug	# 85
push    bc                 

	.debug	# 86
push    de                 

	.debug	# 88
add     sp,-9              

	.debug	# 92
ld      hl,(ix+.f1)        

	.debug	# 93
ex      de,hl              

	.debug	# 94
ld      hl,(ix+.f1+2)      

	.debug	# 95
ld      bc,hl              

	.debug	# 96
ld      a,b                

	.debug	# 97
and     a,7Fh              

	.debug	# 98
or      a,c                

	.debug	# 99
or      a,d                

	.debug	# 100
or      a,e                

	.debug	# 101
jr      z,ret0             

	.debug	# 103
ld      hl,(ix+.f2)        

	.debug	# 104
ex      de,hl              

	.debug	# 105
ld      hl,(ix+.f2+2)      

	.debug	# 106
ld      bc,hl              

	.debug	# 107
ld      a,b                

	.debug	# 108
and     a,7Fh              

	.debug	# 109
or      a,c                

	.debug	# 110
or      a,d                

	.debug	# 111
or      a,e                

	.debug	# 112
jr      nz,not0            

	.debug	# 114
ret0:

	.debug	# 115
ld      de,0               

	.debug	# 116
ld      c,e                

	.debug	# 117
ld      b,e                

	.debug	# 118
jp      done               

	.debug	# 120
not0:

	.debug	# 133
ld      hl,(ix+.f1+2)      

	.debug	# 134
ld      a,h                

	.debug	# 135
ex      de,hl              

	.debug	# 136
rl      de                 

	.debug	# 137
ld      c,d                

	.debug	# 140
ld      hl,(ix+.f2+2)      

	.debug	# 141
xor     h                  

	.debug	# 142
sla     a                  

	.debug	# 143
ex      af,af'             ;[2]  save carry bit with sign bit for result


	.debug	# 144
ex      de,hl              

	.debug	# 145
rl      de                 

	.debug	# 148
bool    hl                 

	.debug	# 149
ld      b,h                

	.debug	# 150
ld      l,d                

	.debug	# 151
add     hl,bc              

	.debug	# 152
ld      de,0xff82          

	.debug	# 153
add     hl,de              

	.debug	# 154
ld      (ix+.expRes),l     

	.debug	# 178
bool    hl                 

	.debug	# 179
ld      hl,(ix+.f1+1)      

	.debug	# 180
set     7,h                

	.debug	# 181
rr      hl                 

	.debug	# 182
ld      bc,hl              

	.debug	# 183
ld      (ix+.man1A),hl     

	.debug	# 186
bool    hl                 

	.debug	# 187
ld      hl,(ix+.f2+1)      

	.debug	# 188
set     7,h                

	.debug	# 189
rr      hl                 

	.debug	# 190
ld      de,hl              

	.debug	# 191
ld      (ix+.man2A),hl     

	.debug	# 194
mul                        

	.debug	# 196
ld      (ix+.manRes+2),hl  

	.debug	# 197
ld      hl,bc              

	.debug	# 198
ld      (ix+.manRes),hl    

	.debug	# 201
ld      hl,(ix+.f2)        

	.debug	# 202
ld      a,h                

	.debug	# 203
and     a,0x01             

	.debug	# 204
ld      b,a                

	.debug	# 205
ld      c,l                

	.debug	# 206
ld      hl,(ix+.man1A)     

	.debug	# 207
ex      de,hl              

	.debug	# 208
mul                        

	.debug	# 209
ld      e,b                

	.debug	# 210
ld      d,l                

	.debug	# 211
rr      de                 

	.debug	# 212
res     7,d                

	.debug	# 214
ld      hl,(ix+.manRes)    

	.debug	# 215
add     hl,de              

	.debug	# 216
ld      (ix+.manRes),hl    

	.debug	# 217
jr      nc,nocarry1        

	.debug	# 218
ld      hl,(ix+.manRes+2)  

	.debug	# 219
inc     hl                 

	.debug	# 220
ld      (ix+.manRes+2),hl  

	.debug	# 221
nocarry1:

	.debug	# 224
ld      hl,(ix+.f1)        

	.debug	# 225
ld      a,h                

	.debug	# 226
and     a,0x01             

	.debug	# 227
ld      b,a                

	.debug	# 228
ld      c,l                

	.debug	# 229
ld      hl,(ix+.man2A)     

	.debug	# 230
ex      de,hl              

	.debug	# 231
mul                        

	.debug	# 232
ld      e,b                

	.debug	# 233
ld      d,l                

	.debug	# 234
rr      de                 

	.debug	# 235
res     7,d                

	.debug	# 237
ld      hl,(ix+.manRes)    

	.debug	# 238
add     hl,de              

	.debug	# 239
ld      (ix+.manRes),hl    

	.debug	# 240
jr      nc,nocarry2        

	.debug	# 241
ld      hl,(ix+.manRes+2)  

	.debug	# 242
inc     hl                 

	.debug	# 243
ld      (ix+.manRes+2),hl  

	.debug	# 244
nocarry2:

	.debug	# 247
ld      hl,(ix+.manRes)    

	.debug	# 248
ex      de,hl              

	.debug	# 249
ld      hl,(ix+.manRes+2)  

	.debug	# 253
rl      de                 

	.debug	# 254
ex      de,hl              

	.debug	# 255
rl      de                 

	.debug	# 256
ex      de,hl              

	.debug	# 258
rl      de                 

	.debug	# 259
ex      de,hl              

	.debug	# 260
rl      de                 

	.debug	# 261
ex      de,hl              

	.debug	# 263
ld      b,(ix+.expRes)     

	.debug	# 266
bit     7,h                

	.debug	# 267
jr      nz,clear1stbit     

	.debug	# 269
rl      de                 

	.debug	# 270
ex      de,hl              

	.debug	# 271
rl      de                 

	.debug	# 272
ex      de,hl              

	.debug	# 274
dec     b                  

	.debug	# 276
clear1stbit:

	.debug	# 277
res     7,h                

	.debug	# 280
ex      af,af'             ;[2]  carry bit contains sign bit for result


	.debug	# 281
rr      b                  

	.debug	# 282
ld      c,0                

	.debug	# 283
rr      c                  

	.debug	# 284
ld      a,c                

	.debug	# 285
or      h                  

	.debug	# 286
ld      c,a                

	.debug	# 287
ld      e,d                

	.debug	# 288
ld      d,l                

	.debug	# 290
done:

	.debug	# 291
ld      sp,ix

	.debug	# 293
pop     ix

	.debug	# 299
pop     hl                 

	.debug	# 300
add     sp,4               

	.debug	# 302
jp      (hl)               

;305 
	.cseg
;306 //-------------------------------------------------------------------------
;307 
	.end
