	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\kernel\timer.c' 28 45 6 24 5 30
;1 //----- timer.c ----- 05/14/10 -----(10/30/07)-----
;2 
;3 //-------------------------------------------------------------------------
;4 //  DEBROS implementation of some of the linux timer.c code
;5 //-------------------------------------------------------------------------
;6 //  Update log (most recent first)
;7 //
;8 //
;9 //  2010-05-14 - Mark Davis (*)
;10 //               - The task's timeoutTicks value is now set to 0 after savi
;11 //                 a copy of it when the task resumes.  This value is now
;12 //                 decremented by the kernel task ONLY if the task is in
;13 //                 a blocked state (i.e. INTERRUPTIBLE or UNINTERRUPTIBLE).
;14 //                 This not only allows schedule_timeout() to return a non-
;15 //                 value, but it means the value no longer has to be protec
;16 //                 by a critical section in this code (because the task's s
;17 //                 WILL be RUNNING when it returns from the call to schedul
;18 //                 so the kernel will not access the timeoutTicks value).
;19 //
;20 //  2009-06-26 - Mark Davis
;21 //               - Added a critical section around the read of task's
;22 //                 timeoutTicks value to guard against preemption.  Without
;23 //                 this, the read could get a non-zero value just before it
;24 //                 gets preempted and set to 0, causing the task
;25 //
;26 //
;27 //  2007-10-30 - Mark Davis
;28 //               - first version containing just schedule_timeout()
;29 //
;30 //-------------------------------------------------------------------------
;31 
;32 
;33 #include <common.h>
;34 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
	.debug	I
;35 #include <unistd.h>
;36 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	# 109
_LIN2SEG	.macro

	.debug	# 110
add hl,hl

	.debug	# 111
rla

	.debug	# 112
add hl,hl

	.debug	# 113
rla

	.debug	# 114
add hl,hl

	.debug	# 115
rla

	.debug	# 116
add hl,hl

	.debug	# 117
rla

	.debug	# 118
sub 0x0E

	.debug	# 119
or a

	.debug	# 120
rr hl

	.debug	# 121
scf

	.debug	# 122
rr hl

	.debug	# 123
scf

	.debug	# 124
rr hl

	.debug	# 125
scf

	.debug	# 126
rr hl

	.debug	# 127
.endm

	.cseg
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
	.debug	I
	.debug	I
	.debug	I
;37 #include <linux/sched.h>
;38 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
;39 #include <linux/wait.h>
;40 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
;41 #include <linux/dummy.h>
;42 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	I
;43 #include <string.h>
;44 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
;45 #include <rabbit.h>
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\rabbit.h' 24 40 11 19 5 30
	.debug	I
;46 #include <dcdefs.h>
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I
;47 #include <limits.h>
;48 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	I
;49 
;50 
;51 /*-------------------------------------------------------------------------
;52  * schedule_timeout - sleep until timeout
;53  * @timeout: timeout value in jiffies
;54  *
;55  * Make the current task sleep until @timeout jiffies have
;56  * elapsed. The routine will return immediately unless
;57  * the current task state has been set (see set_current_state()).
;58  *
;59  * You can set the task state as follows -
;60  *
;61  * %TASK_UNINTERRUPTIBLE - at least @timeout jiffies are guaranteed to
;62  * pass before the routine returns. The routine will return 0
;63  *
;64  * NSCL NOTE:  This is misleading.  @timeout jiffies are NOT guaranteed
;65  *             to pass if current has registered itself in a wait queue!
;66  *
;67  * %TASK_INTERRUPTIBLE - the routine may return early if a signal is
;68  * delivered to the current task. In this case the remaining time
;69  * in jiffies will be returned, or 0 if the timer expired in time
;70  *
;71  * The current task state is guaranteed to be TASK_RUNNING when this
;72  * routine returns.
;73  *
;74  * Specifying a @timeout value of %MAX_SCHEDULE_TIMEOUT will schedule
;75  * the CPU away without a bound on the timeout. In this case the return
;76  * value will be %MAX_SCHEDULE_TIMEOUT.
;77  *
;78  * In all cases the return value is guaranteed to be non-negative.
;79  --------------------------------------------------------------------------
;80 fastcall signed long __sched schedule_timeout(signed long timeout)
;81 {
	.defseg	FARCODE
	.seg	FARCODE
$schedule_timeout::
	.debug	G $schedule_timeout 32 9
	.debug	{ $schedule_timeout 32 80 @3 @2
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A timeout 5 8
;82 //  struct timer_list timer;
;83 //  unsigned long expire;
;84 
;85 
;86   switch (timeout)
	.debug	# 86
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	jr	@4
;87   {
;88   case MAX_SCHEDULE_TIMEOUT:
@6:
	.debug	< @6 @7
;89     /*
;90      * These two special cases are useful to be comfortable
;91      * in the caller. Nothing more. We could take
;92      * MAX_SCHEDULE_TIMEOUT from one of the negative value
;93      * but I' d like to return a valid offset (>=0) to allow
;94      * the caller to do everything it want with the retval.
;95      */
;96     schedule();
	.debug	# 96
@8:
	lcall	$schedule
;97     goto out;
	.debug	# 97
	jp	@9
;98   default:
;99     /*
;100      * Another bit of PARANOID. Note that the retval will be
;101      * 0 since no piece of kernel is supposed to do a check
;102      * for a negative retval of schedule_timeout() (since it
;103      * should never happens anyway). You just have the printk()
;104      * that will tell you if something is gone wrong and where.
;105      */
;106     if (timeout < 0) {
	.debug	# 106
@10:
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__lcmp##
	jr	nc,@5
;107 //      printk(KERN_ERR "schedule_timeout: wrong timeout "
;108 //        "value %lx\n", timeout);
;109       fprintf(DiagLog, "schedule_timeout: wrong timeout value %lx\n", timeo
@12:
	.debug	< @12 @13
	.debug	# 109
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,@14
	push	hl
	ld	hl,_diagLog
	push	hl
	lcall	$fprintf
	add	sp,8
;110 //      dump_stack();
;111       current->state = TASK_RUNNING;
	.debug	# 111
	ld	hl,(_current)
	ld	de,0x13
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
;112       goto out;
	.debug	# 112
	jr	@9
;113     }
@13:
	.debug	>
;114   }
@7:
	.debug	>
;115 
;116 /*
;117   expire = timeout + jiffies;
;118 
;119   setup_timer(&timer, process_timeout, (unsigned long)current);
;120   __mod_timer(&timer, expire);
;121   schedule();
;122   del_singleshot_timer_sync(&timer);
;123 
;124   timeout = expire - jiffies;
;125 */
;126 
;127 //  printf("-----block for upto %ld ticks\r\n", timeout);  //tdebug
;128 
;129   _EnterCritical_();  current->timeoutTicks = timeout;  _ExitCritical_();
@4:
	ld	hl,0x1
	add	hl,de
	bool	hl
	jr	nz,@10
	ld	hl,0xffff8001
	add	hl,bc
	bool	hl
	jr	z,@8
	jr	@10
@5:
	.debug	# 129
	ipset	2
	ld	hl,(_current)
	ld	de,0xe4
	add	hl,de
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ipres
;130 
;131   schedule();
	.debug	# 131
	lcall	$schedule
;132 
;133   //NOTE:  timeoutTicks is decremented only by the kernel and only if the
;134   //       task is blocked (i.e. INTERRUPTIBLE or UNINTERRUPTIBLE)
;135   timeout = (long) current->timeoutTicks;  // # of ticks left
	.debug	# 135
	ld	hl,(_current)
	ld	de,0xe4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix+7),hl
	ex	de,hl
	ld	(ix+5),hl
	ex	de,hl
;136   current->timeoutTicks = 0;
	.debug	# 136
	ld	hl,(_current)
	ld	de,0xe4
	add	hl,de
	ld	e,d
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;137 
;138   if (timeout < 0)  timeout = 0;
	.debug	# 138
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__lcmp##
	jr	nc,@16
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix+7),hl
	ex	de,hl
	ld	(ix+5),hl
	ex	de,hl
;139 
;140 //  printf("----- ticks left: %ld\r\n", timeout);  //tdebug
;141 
;142  out:
@16:
	.debug	# 142
@9:
;143   return timeout;  // returns # ticks left
	.debug	# 143
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
;144 }
@2:
	.debug	} @2 144

@1	equ	0
	pop	ix
	lret
@3	equ	2
;145 EXPORT_SYMBOL(schedule_timeout);
;146 
;147 
;148 /*-------------------------------------------------------------------------
;149  * We can use __set_current_state() here because schedule_timeout() calls
;150  * schedule() unconditionally.
;151  --------------------------------------------------------------------------
;152 signed long __sched schedule_timeout_interruptible(signed long timeout)
;153 {
$schedule_timeout_interruptible::
	.debug	G $schedule_timeout_interruptible 32 9
	.debug	{ $schedule_timeout_interruptible 32 152 @19 @18
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A timeout 5 8
;154   __set_current_state(TASK_INTERRUPTIBLE);
@23:
	.debug	< @23 @24
	.debug	# 154
	ld	hl,(_current)
	ld	de,0x13
	add	hl,de
	ld	e,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
@24:
	.debug	>
;155   return schedule_timeout(timeout);
	.debug	# 155
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$schedule_timeout
	add	sp,4
;156 }
@18:
	.debug	} @18 156

@17	equ	0
	pop	ix
	lret
@19	equ	2
;157 EXPORT_SYMBOL(schedule_timeout_interruptible);
;158 
;159 //-------------------------------------------------------------------------
;160 signed long __sched schedule_timeout_uninterruptible(signed long timeout)
;161 {
$schedule_timeout_uninterruptible::
	.debug	G $schedule_timeout_uninterruptible 32 9
	.debug	{ $schedule_timeout_uninterruptible 32 160 @27 @26
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A timeout 5 8
;162   __set_current_state(TASK_UNINTERRUPTIBLE);
@31:
	.debug	< @31 @32
	.debug	# 162
	ld	hl,(_current)
	ld	de,0x13
	add	hl,de
	ld	e,0x2
	ld	(hl),e
	inc	hl
	ld	(hl),d
@32:
	.debug	>
;163   return schedule_timeout(timeout);
	.debug	# 163
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$schedule_timeout
	add	sp,4
;164 }
@26:
	.debug	} @26 164

@25	equ	0
	pop	ix
	lret
@27	equ	2
;165 EXPORT_SYMBOL(schedule_timeout_uninterruptible);
;166 
;167 
;168 //-------------------------------------------------------------------------
;169 
	.extern	_current 33
	.cseg
_schedule:
	pop	iy
	lcall	$$schedule
	.extern	$$schedule
	.extern	$schedule 35
	.extern	$fprintf 36
	.extern	_diagLog 37
	.debug	T	0B000220000100080008000000
	.debug	T	070000210002002200
	.debug	T	7702032200E8002D000C7461736B5F737472756374002600000006
	.debug	T	737461636B00260002000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C68720027000F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465002100150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	0005617267630029001A000561726776002B001C0005617267
	.debug	T	73002C009C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C616773002D00B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74002F00D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	0B000223000100010001000000
	.debug	T	130002240003000600300000002A0002000D000000
	.debug	T	54000325000C000600010031000000065F5F6F7574003300020005
	.debug	T	5F5F696E0035000400085F5F77726974650035000600075F5F
	.debug	T	726561640006000800085F5F756E6765740037000A000B5F5F
	.debug	T	757365724461746100
	.debug	T	070000260002000700
	.debug	T	070000270002002800
	.debug	T	070008280004000100
	.debug	T	070000290002002A00
	.debug	T	0700002A0002000300
	.debug	T	0900012B00800003008000
	.debug	T	2800032C0004000100125F5F776169745F71756575655F68656164
	.debug	T	0038000000096C6973744865616400
	.debug	T	0700002D0002002E00
	.debug	T	0F00022E00020001000600000029000200
	.debug	T	0700082F0004000300
	.debug	T	070000300002002500
	.debug	T	070000310002003200
	.debug	T	0F00023200020006000300000037000200
	.debug	T	070000330002003400
	.debug	T	0B000234000100060037000000
	.debug	T	070000350002003600
	.debug	T	1300023600030008002F0000000800040037000800
	.debug	T	070000370002000100
	.debug	T	2600033800040002000A6C6973745F686561640039000000056E65
	.debug	T	78740039000200057072657600
	.debug	T	070000390002003800
	.defseg	CONST
	.seg	CONST
@14:
	.db	"schedule_timeout: wrong timeout value %lx",10,0
	.end
