//----- srfs.c ----- 03/31/09 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <sys/srfs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <sys/modbus.h>

#include <tsh.h>

#include <applic.h>

#include <sys/farprintf.h>

//-----------------------------------------------------------------------------
//  Show/Set SRFS service parameters
//-----------------------------------------------------------------------------
void _task _srfs(int argc, char **argv)
{
  ulong  newAddr;
  char  ipStr[16];


  if (showHelp(1, argc, argv))  {
    printf("\nusage:  srfs [newSrvAddr]\n");  Exit(-1); }


  if (argc > 1)  {
    newAddr = 0;  inet_ptoh(AF_INET, argv[1], &newAddr);
    if (! newAddr)  {
      printf("Invalid IP address: %s\r\n", argv[1]);  Exit(-1);  }
    srfsIPAddr = newAddr;
    Exit(0);
  }

  inet_htop(AF_INET, &srfsIPAddr,  ipStr,   sizeof(ipStr));
  printf("%s\r\n", ipStr);

  Exit(0);
}


//-----------------------------------------------------------------------------
