//----- msgs.h ----- 03/22/06 -----(03/21/06)-----

#ifndef _msgsH_
#define _msgsH_


typedef struct  {
  uchar  id;
  PID    sender;
  uchar  len;
} MsgHdr;


typedef struct  {
  int  stat;  // status return for last msg
} RespMsg;


typedef struct  {
  PID  pid;
} KillMsg;


typedef struct  {
  int  (*testFunc)(void *testData);
  void  *testData;
}  BlockUntilMsg;


#define  MSG_RESP         1   // response to last msg/request
#define  MSG_KILL         2   // request to kill a process
#define  MSG_BLOCK_UNTIL  3   // respond when TestFunc returns a non-zero value


#endif
