	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\kernel\semaphore.c' 8 50 12 25 4 32
;1 //----- semaphore.c ----- 04/23/12 -----(07/22/10)-----
;2 
;3 //=========================================================================
;4 //  POSIX style semaphores
;5 //=========================================================================
;6 // NOTES
;7 //
;8 //=========================================================================
;9 //  Change log (most recent first):
;10 //
;11 //
;12 //  2012-04-23 - Mark Davis
;13 //               - Added semCounts() to get total and free counts for the
;14 //                 global pool of named semaphores.
;15 //
;16 //  2012-04-19 - Mark Davis (*)
;17 //               - Fixed some bugs in sem_wait_() (used by all cases of get
;18 //                 a lock on a semaphore).  Prior to this, if a task was
;19 //                 resumed but did not get the semaphore, it would still be
;20 //                 in the semaphores blocked queue, which could not only
;21 //                 cause the task to resume when it shouldn't, but could
;22 //                 use up the free waitqueue nodes.
;23 //                 NOTE that this could affect all uses of semaphores (whic
;24 //                 includes the poll() function).
;25 //
;26 //  2010-08-12 - Mark Davis
;27 //               - First version to pass basic tests (see sem_test command 
;28 //                 the test application).
;29 //
;30 //  2010-07-22 - Mark Davis
;31 //               - Began work on first version.
;32 //
;33 //=========================================================================
;34 
;35 #include <common.h>
;36 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
	.debug	I
;37 #include <linux/sched.h>
;38 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I
;39 #include <sys/types.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
;40 #include <errno.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\errno.h' 22 0 10 11 8 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	# 109
_LIN2SEG	.macro

	.debug	# 110
add hl,hl

	.debug	# 111
rla

	.debug	# 112
add hl,hl

	.debug	# 113
rla

	.debug	# 114
add hl,hl

	.debug	# 115
rla

	.debug	# 116
add hl,hl

	.debug	# 117
rla

	.debug	# 118
sub 0x0E

	.debug	# 119
or a

	.debug	# 120
rr hl

	.debug	# 121
scf

	.debug	# 122
rr hl

	.debug	# 123
scf

	.debug	# 124
rr hl

	.debug	# 125
scf

	.debug	# 126
rr hl

	.debug	# 127
.endm

	.cseg
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
	.debug	I
	.debug	I
	.debug	I
	.debug	I
;41 #include <unistd.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
;42 #include <fcntl.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I
;43 #include <sys/stat.h>
;44 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\stat.h' 0 48 10 31 3 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I
;45 #include <signal.h>
;46 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
;47 #include <sys/time.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\time.h' 10 37 11 8 3 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I
;48 #include <semaphore.h>
;49 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I
;50 #include <limits.h>
;51 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	I
;52 
;53 //#define  SEM_DEBUG
;54 
;55 
;56 static sem_t  semaphores[MAX_NUM_SEMS];
;57 static char far  names[MAX_NUM_SEMS][NAME_MAX];
;58 
;59 
;60 //-------------------------------------------------------------------------
;61 //  Notes on software logic:
;62 //-----------------------------
;63 //
;64 //  Managing the state of the semaphores is handled by maintaining 3 lists
;65 //  for each semaphore:
;66 //
;67 //    - The tasks that have opened the semaphore (for named semaphores)
;68 //    - The locks in use
;69 //    - The tasks blocked waiting for a lock
;70 //
;71 //  Locking:
;72 //
;73 //    To avoid concurrency problems and corrupted lists, all scans of and
;74 //    changes to a list must be done using a lock that insures no other tas
;75 //    modifies a list while other tasks are reading it or modifying it.  At
;76 //    present this is done by disabling the scheduler, although in the futu
;77 //    support for semaphore-specific locking (and even RO vs RW locks) woul
;78 //    reduce the effect on latency.  Although this is sort of a chicken-&-e
;79 //    problem since you would need something like a semaphore to do it...
;80 //
;81 //
;82 //  Adding/Removing nodes to/from the queues/lists:
;83 //
;84 //    It is important to add nodes to the END/tail of queues.  The reason f
;85 //    this is that each node belongs to 2 lists:  One for the resource the
;86 //    node represents, and one for the task that owns or is waiting for the
;87 //    resource.  Because you have to open a named semaphore before you can 
;88 //    a lock (or block) on it, adding nodes to the end of the lists ensures
;89 //    the 'open" nodes will always come before any 'lock' or 'blocked' node
;90 //    in each task's list.
;91 //
;92 //    This is important because when a task is killed, all its nodes are
;93 //    removed (and processed) in reverse order (from the tail to the head),
;94 //    causing any locks the task has for a semaphore to be released before 
;95 //    connection to the semaphore is closed.  While doing it in the other
;96 //    order is possible, it would require more time searching through lists
;97 //    which has to be done inside a lock, which would have a larger impact
;98 //    on latency.
;99 //
;100 //
;101 //  Granting locks in the order they were requested:
;102 //
;103 //    When there are tasks blocked waiting for a lock, we want to insure th
;104 //    the next one in the blocked list gets the next lock that is released.
;105 //
;106 //    To insure this happens, the release (posting) of a lock is handled as
;107 //    follows:
;108 //
;109 //      - The locked node for the task that called post is removed from the
;110 //        lock node queue for the semaphore.
;111 //
;112 //      - If there are no blocked tasks waiting for a lock, the value of th
;113 //        semaphore is increased so the next request for a lock can be
;114 //        satisfied without waiting or blocking.
;115 //
;116 //      - If there are blocked tasks waiting for a lock, the value of the
;117 //        semaphore is NOT increased.  Instead, the node for a blocked task
;118 //        simply moved from the blocked list to the locked list and the blo
;119 //        task is resumed.  This insures that the unblocked task owns the
;120 //        just-released lock and that it cannot be given to another task be
;121 //        the unblocked one actually resumes execution.
;122 //
;123 //   NOTE:
;124 //     Currently, the first task (if any) in a semaphore's list of blocked
;125 //     tasks is the one that receives a lock when it is released.  While
;126 //     this a simple and efficient approach that ensures a degree of "fairn
;127 //     (first come, first serve), it can result in priority-inversion and i
;128 //     violates the priority-based model of the scheduler.  A later version
;129 //     should really call a scheduler function that determines which task
;130 //     should be resumed.
;131 //
;132 //
;133 //  Semaphore pointers:
;134 //
;135 //    The POSIX-style semaphore functions use a pointer to a sem_t value to
;136 //    reference each semaphore.
;137 //
;138 //    For named semaphores, each task gets the pointer value needed to acce
;139 //    the semaphore by calling sem_open(), so the pointer value returned co
;140 //    be different for different tasks.  So long as the correct semaphore i
;141 //    accessed for a given pointer, this works just fine.
;142 //
;143 //    For unnamed semaphores, there is no standard way to get a pointer val
;144 //    for the semaphore.  The pointer value must be known BEFORE calling AN
;145 //    of the semaphore functions.  This includes sem_init(), which must
;146 //    be called just once to initialize an unnamed semaphore before any oth
;147 //    call that references the semaphore.
;148 //
;149 //    As with named semaphores, so long as the semaphore functions access t
;150 //    correct semaphore, the value of the pointer COULD be different for ea
;151 //    task.  But for there to be any hope of portability, there must be som
;152 //    standard way for multiple tasks to determine what pointer value to us
;153 //    to access a given semaphore.
;154 //
;155 //    The most natural assumption is that the sem_t pointer actually points
;156 //    to a sem_t value in shared memory and is accessable by all the tasks
;157 //    that need to use the semaphore.
;158 //
;159 //    At the time of this writing, DEBROS does not (yet) support the shared
;160 //    memory functions (shm_open, shm_unlink, shmat, shmctl, shmdt, shmget,
;161 //    shmop) which is the only portable way I know of for multiple tasks to
;162 //    get a pointer to an object in shared memory.
;163 //
;164 //    Of course, in DEBROS (and I suspect many Real-Time OS's), all of memo
;165 //    is shared, so any variable declared in global memory is automatically
;166 //    accessible by all tasks.
;167 //
;168 //    So, for DEBROS, an unnamed semaphore can be shared by multiple tasks
;169 //    simply by declaring it in global memory (as opposed to a local variab
;170 //    that resides in a task's stack) and then using its address when
;171 //    calling any of the semaphore functions.
;172 //
;173 //    Note that an unnamed semaphore CAN reside on the stack if it is NOT
;174 //    shared with other tasks.  Although, since DEBROS does not support
;175 //    multiple threads within a task, such a semaphore would probably not b
;176 //    particularly useful.
;177 //
;178 //
;179 //  Assumptions regarding unspecified behavior:
;180 //
;181 //    The manual pages I have found that describe these functions leave out
;182 //    number of details which I have decided to implement in a manner that
;183 //    makes the most sense to me and which I believe will minimize the chan
;184 //    for problems:
;185 //
;186 //    - Can a task aquire more than one lock on a semaphore?  Nothing I
;187 //      found says one way or the other, and I can envision scenarios where
;188 //      a single task might need to tie up multiple instances of the resour
;189 //      the semaphore represents, so the DEBROS implementation supports thi
;190 //
;191 //    - If a task closes a semaphore when it has 1 or more active locks on
;192 //      the semaphore, what should happen to the locks?  The manual page
;193 //      says that it deallocates any system resources allocated for the
;194 //      process' use of the semaphore.  That would seem to support my belie
;195 //      that the only thing that makes sense is to release the locks before
;196 //      returning from the sem_close call, so that is what the DEBROS
;197 //      implementation does.
;198 //
;199 //    - In many places the manual pages say that the effect of some set of
;200 //      circumstances is undefined (e.g. calling sem_destroy() for a named
;201 //      semaphore).  Wherever possible, I try to detect such circumstances
;202 //      and return an error without altering the state of any semaphore.
;203 //
;204 //-------------------------------------------------------------------------
;205 
;206 
;207 #ifdef SEM_DEBUG
;230 
;231 //-------------------------------------------------------------------------
;232 //  Check a pointer to see if it points to a valid, named semaphore.
;233 //
;234 //  Returns non-0 if the pointer refers to a named semaphore structure that
;235 //  been initialized via a sem_open() call and is still in use.
;236 //
;237 //  Locking must be handled by caller.
;238 //-------------------------------------------------------------------------
;239 bool  namedSemaphore(sem_t *sem)
;240 {
	.defseg	FARCODE
	.seg	FARCODE
$namedSemaphore::
	.debug	G $namedSemaphore 32 9
	.debug	{ $namedSemaphore 32 239 @3 @2
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A sem 5 33
;241   return (!INVALID(sem_t, sem) AND sem->name AND sem->inUse);
	.debug	# 241
	ld	hl,@4
	push	hl
	ld	hl,@4+15
	push	hl
	ld	hl,(ix+5)
	ld	de,0x14
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$ValidatePtr
	add	sp,8
	bool	hl
	jr	nz,@6
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@6
	ld	hl,(ix+5)
	ld	de,0x11
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@6
	ld	a,1
	jr	@2
@6:
	xor	a
;242 }
@2:
	.debug	} @2 242

@1	equ	0
	pop	ix
	lret
@3	equ	2
;243 
;244 //-------------------------------------------------------------------------
;245 //  Check a pointer to see if it points to a valid, unnamed semaphore.
;246 //
;247 //  Returns non-0 if the pointer refers to an unnamed semaphore structure t
;248 //  has been initialized via a sem_init() call and is still in use.
;249 //
;250 //  Locking must be handled by caller.
;251 //-------------------------------------------------------------------------
;252 bool  unnamedSemaphore(sem_t *sem)
;253 {
$unnamedSemaphore::
	.debug	G $unnamedSemaphore 32 9
	.debug	{ $unnamedSemaphore 32 252 @10 @9
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A sem 5 33
;254   return (!INVALID(sem_t, sem) AND !sem->name AND sem->inUse);
	.debug	# 254
	ld	hl,@4+21
	push	hl
	ld	hl,@4+15
	push	hl
	ld	hl,(ix+5)
	ld	de,0x14
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$ValidatePtr
	add	sp,8
	bool	hl
	jr	nz,@12
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@12
	ld	hl,(ix+5)
	ld	de,0x11
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@12
	ld	a,1
	jr	@9
@12:
	xor	a
;255 }
@9:
	.debug	} @9 255

@8	equ	0
	pop	ix
	lret
@10	equ	2
;256 
;257 //-------------------------------------------------------------------------
;258 int qListSize(WaitQueue *wq)
;259 {
$qListSize::
	.debug	G $qListSize 35 9
	.debug	{ $qListSize 35 258 @16 @15
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A wq 5 36
;260   int  count;
	.debug	L count -2 6
;261   list_head_t  *cur, *list;
	.debug	L cur -4 38
	.debug	L list -6 38
;262 
;263 
;264   list = &wq->listHead;  count = 0;
	.debug	# 264
	ld	hl,(ix+5)
	ld	(ix-6),hl
	bool	hl
	ld	l,h
	ld	(ix-2),hl
;265 
;266   list_for_each(cur, list)  ++count;
@17:
	.debug	< @17 @18
	.debug	# 266
	ld	hl,(ix-6)
	ld	hl,(hl)
	ld	(ix-4),hl
@19:
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@20
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
;267 
;268   return count;
	ld	h,d
	ld	l,e
	ld	hl,(hl)
	ld	(ix-4),hl
	jr	@19
@20:
@18:
	.debug	>
	.debug	# 268
	ld	hl,(ix-2)
;269 }
@15:
	.debug	} @15 269

@14	equ	6
	ld	sp,ix
	pop	ix
	lret
@16	equ	8
;270 
;271 //-------------------------------------------------------------------------
;272 //  Scan the nodes in a queue looking for one that points to a specific tas
;273 //
;274 //  Returns a pointer to the first node found (if any), or NULL if none of 
;275 //  nodes in the list point to the task.
;276 //
;277 //  Locking must be handled by caller.
;278 //-------------------------------------------------------------------------
;279 WaitQueueNode *taskInQList(WaitQueue *wq, task_t *task)
;280 {
$taskInQList::
	.debug	G $taskInQList 40 9
	.debug	{ $taskInQList 40 279 @24 @23
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A wq 5 36
	.debug	A task 7 43
;281   list_head_t  *cur, *list;
	.debug	L cur -2 38
	.debug	L list -4 38
;282   WaitQueueNode  *node;
	.debug	L node -6 41
;283 
;284 
;285   list = &wq->listHead;
	.debug	# 285
	ld	hl,(ix+5)
	ld	(ix-4),hl
;286 
;287   list_for_each(cur, list)  {
@25:
	.debug	< @25 @26
	.debug	# 287
	ld	hl,(hl)
	ld	(ix-2),hl
@27:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@28
;288     node = list_entry(cur, WaitQueueNode, taskList);
@30:
	.debug	< @30 @31
	.debug	# 288
	ld	h,d
	ld	l,e
	ld	de,0xfff8
	add	hl,de
	ld	(ix-6),hl
;289     if (node->task == task)  return node;
	.debug	# 289
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@32
	ld	hl,(ix-6)
	jr	@23
;290   }
@32:
@31:
	.debug	>
;291 
;292   return NULL;
	ld	hl,(ix-2)
	ld	hl,(hl)
	ld	(ix-2),hl
	jr	@27
@28:
@26:
	.debug	>
	.debug	# 292
	bool	hl
	ld	l,h
;293 }
@23:
	.debug	} @23 293

@22	equ	6
	ld	sp,ix
	pop	ix
	lret
@24	equ	8
;294 
;295 
;296 //-------------------------------------------------------------------------
;297 //  Determine if a node is one of the ones in a specified queue.
;298 //
;299 //  This is done by scanning the queue list the node is in to see if one of
;300 //  the nodes is the listhead node for the specified queue.
;301 //
;302 //  Returns true if the node is in the specified queue,  false if it is not
;303 //
;304 //  NOTE:  This works best if the node is the LAST node in the queue (i.e.
;305 //  the node's next pointer points to the node for the queue's list head).
;306 //
;307 //  Locking must be handled by caller.
;308 //-------------------------------------------------------------------------
;309 bool nodeInQList(WaitQueue *wq, WaitQueueNode *node)
;310 {
$nodeInQList::
	.debug	G $nodeInQList 45 9
	.debug	{ $nodeInQList 45 309 @35 @34
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A wq 5 36
	.debug	A node 7 41
;311   list_head_t  *cur, *start, *list;
	.debug	L cur -2 38
	.debug	L start -4 38
	.debug	L list -6 38
;312 
;313 
;314   list = &wq->listHead;  start = &node->taskList;
	.debug	# 314
	ld	hl,(ix+5)
	ld	(ix-6),hl
	ld	hl,(ix+7)
	ld	de,0x8
	add	hl,de
	ld	(ix-4),hl
;315 
;316   for (cur=start->next; cur!=start; cur=cur->next)
@36:
	.debug	< @36 @37
	.debug	# 316
	ld	hl,(hl)
	ld	(ix-2),hl
@38:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@39
;317     if (cur == list)  return true;
	.debug	# 317
	ld	hl,(ix-6)
	or	a,a
	sbc	hl,de
	jr	nz,@41
	ld	a,0x1
	jr	@34
;318 
;319   return false;
@41:
	ld	hl,(ix-2)
	ld	hl,(hl)
	ld	(ix-2),hl
	jr	@38
@39:
@37:
	.debug	>
	.debug	# 319
	xor	a,a
;320 }
@34:
	.debug	} @34 320

@33	equ	6
	ld	sp,ix
	pop	ix
	lret
@35	equ	8
;321 
;322 
;323 //-------------------------------------------------------------------------
;324 //  Free up any locks a task has for a semaphore.  If other tasks are block
;325 //  waiting for a lock, one of them is given the lock and unblocked.
;326 //
;327 //  Locking must be handled by caller.
;328 //-------------------------------------------------------------------------
;329 void semFreeLocks(sem_t *sem, task_t *task)
;330 {
$semFreeLocks::
	.debug	G $semFreeLocks 46 9
	.debug	{ $semFreeLocks 46 329 @44 @43
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	.debug	A sem 5 33
	.debug	A task 7 43
;331   list_head_t  *cur, *next, *list;
	.debug	L cur -2 38
	.debug	L next -4 38
	.debug	L list -6 38
;332   WaitQueueNode  *node;
	.debug	L node -8 41
;333   WaitQueue  *locked;
	.debug	L locked -10 36
;334 
;335 
;336 //--- free up any locks the task may have had ---
;337   locked = &sem->locked;  list = &locked->listHead;
	.debug	# 337
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	(ix-10),hl
	ld	(ix-6),hl
;338 
;339 //--- NOTE that removal of a node from the locked list causes ---
;340 //--- semRemovedFromLockedList() to be called, which gives the just-release
;341 //---- lock to another task if one is blocked, waiting for a lock ---
;342 
;343   list_for_each_safe(cur, next, list)  {
@45:
	.debug	< @45 @46
	.debug	# 343
	ld	hl,(hl)
	ld	(ix-2),hl
	ld	hl,(hl)
	ld	(ix-4),hl
@47:
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@48
;344     node = list_entry(cur, WaitQueueNode, taskList);
@50:
	.debug	< @50 @51
	.debug	# 344
	ld	h,d
	ld	l,e
	ld	de,0xfff8
	add	hl,de
	ld	(ix-8),hl
;345     if (node->task == task)  {
	.debug	# 345
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@52
;346       __removeWaitQueue(locked, node);  free_WaitQueueNode(node);  }
@53:
	.debug	< @53 @54
	.debug	# 346
	ld	hl,(ix-8)
	push	hl
	ld	hl,(ix-10)
	push	hl
	lcall	$__removeWaitQueue
	add	sp,4
	ld	hl,(ix-8)
	push	hl
	lcall	$free_WaitQueueNode
	pop	hl
@54:
	.debug	>
;347   }
@52:
@51:
	.debug	>
;348 
;349 }
	ld	hl,(ix-4)
	ld	(ix-2),hl
	ld	hl,(hl)
	ld	(ix-4),hl
	jr	@47
@48:
@46:
	.debug	>
@43:
	.debug	} @43 349

@42	equ	10
	ld	sp,ix
	pop	ix
	lret
@44	equ	12
;350 
;351 
;352 //-------------------------------------------------------------------------
;353 //  Called to see if a named, unlinked semaphore can be freed
;354 //
;355 //  Must only be called for named, unlinked semaphores.
;356 //
;357 //  Locking must be handled by caller.
;358 //-------------------------------------------------------------------------
;359 void semFreeIfNotOpen(sem_t *sem)
;360 {
$semFreeIfNotOpen::
	.debug	G $semFreeIfNotOpen 47 9
	.debug	{ $semFreeIfNotOpen 47 359 @57 @56
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A sem 5 33
;361   WaitQueue  *opened, *locked, *blocked;
	.debug	L opened -2 36
	.debug	L locked -4 36
	.debug	L blocked -6 36
;362 
;363 
;364   opened = &sem->opened;  if (waitqueue_active(opened))  return;
	.debug	# 364
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	(ix-2),hl
	ex	de,hl
	ld	h,d
	ld	l,e
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	ld	hl,0
	jr	nz,@58
	inc	l
@58:
	bool	hl
	ld	l,h
	jr	nz,@59
	inc	l
@59:
	bool	hl
	jr	nz,@56
;365 
;366   blocked = &sem->blocked;  locked = &sem->locked;
	.debug	# 366
	ld	hl,(ix+5)
	ld	de,0xc
	add	hl,de
	ld	(ix-6),hl
	ld	hl,(ix+5)
	ld	e,0x8
	add	hl,de
	ld	(ix-4),hl
;367 
;368   if (waitqueue_active(blocked))  {
	.debug	# 368
	ld	hl,(ix-6)
	ex	de,hl
	ld	h,d
	ld	l,e
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	ld	hl,0
	jr	nz,@61
	inc	l
@61:
	bool	hl
	ld	l,h
	jr	nz,@62
	inc	l
@62:
	bool	hl
	jr	z,@63
;369     fprintf(DiagLog, "*** %s on fully closed, unlinked semaphore ***\n",
@64:
	.debug	< @64 @65
;370             "blocked tasks");
	.debug	# 370
	ld	hl,@4+38
	jr	@296
;371     return;
	.debug	# 371
;372   }
@65:
	.debug	>
;373   if (waitqueue_active(locked))  {
@63:
	.debug	# 373
	ld	hl,(ix-4)
	ex	de,hl
	ld	h,d
	ld	l,e
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	ld	hl,0
	jr	nz,@66
	inc	l
@66:
	bool	hl
	ld	l,h
	jr	nz,@67
	inc	l
@67:
	bool	hl
	jr	z,@68
;374     fprintf(DiagLog, "*** %s on fully closed, unlinked semaphore ***\n",
@69:
	.debug	< @69 @70
;375             "locks");
	.debug	# 375
	ld	hl,@4+100
@296:
	push	hl
	ld	hl,@4+52
	push	hl
	ld	hl,_diagLog
	push	hl
	lcall	$fprintf
	add	sp,6
;376     return;
	.debug	# 376
;377   }
	jr	@56
@70:
	.debug	>
;378 
;379   #ifdef SEM_DEBUG
;383   sem->inUse = sem->unlinked = false;
@68:
	.debug	# 383
	ld	hl,(ix+5)
	ld	de,0x10
	add	hl,de
	xor	a,a
	ld	(hl),a
	ld	hl,(ix+5)
	inc	e
	add	hl,de
	ld	(hl),a
;384 }
@56:
	.debug	} @56 384

@55	equ	6
	ld	sp,ix
	pop	ix
	lret
@57	equ	8
;385 
;386 
;387 
;388 //-------------------------------------------------------------------------
;389 //  Called just after a node is removed from the "open" list for a semaphor
;390 //
;391 //  If the node was the last one in the semaphore's list of open connection
;392 //  and sem_unlink() was called for the semaphore, then the semaphore is
;393 //  destroyed (freed up for use in a sem_open() or sem_init() call).
;394 //
;395 //  Locking must be handled by caller.
;396 //-------------------------------------------------------------------------
;397 void _nearcall semRemovedFromOpenList(WaitQueueNode *node)
;398 {
	.align	4
$$semRemovedFromOpenList::
	ex	(sp),iy
$semRemovedFromOpenList::
	.debug	G $semRemovedFromOpenList 48 9
	.debug	{ $semRemovedFromOpenList 48 397 @73 @72
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A node 5 41
;399   sem_t  *sem = (sem_t *)node->obj;
	.debug	L sem -2 33
	.debug	# 399
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
	.seg	FARCODE
;400 
;401   if (!namedSemaphore(sem))  return;
	.debug	# 401
	push	hl
	lcall	$namedSemaphore
	pop	hl
	or	a,a
	jr	z,@72
;402 
;403   semFreeLocks(sem, node->task);
	.debug	# 403
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$semFreeLocks
	add	sp,4
;404 
;405   if (sem->unlinked)  semFreeIfNotOpen(sem);
	.debug	# 405
	ld	hl,(ix-2)
	ld	de,0x10
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@75
	ld	hl,(ix-2)
	push	hl
	lcall	$semFreeIfNotOpen
	pop	hl
;406 }
@75:
@72:
	.debug	} @72 406

@71	equ	2
	ld	sp,ix
	pop	ix
	lret
@73	equ	4
;407 
;408 //-------------------------------------------------------------------------
;409 //  Release the lock represented by the specified node that was just remove
;410 //  from the locked list.  If others tasks are blocked waiting for a lock, 
;411 //  of them is given the just-released lock and then unblocked.
;412 //
;413 //  Locking must be handled by caller.
;414 //-------------------------------------------------------------------------
;415 void _nearcall semRemovedFromLockedList(WaitQueueNode *node)
;416 {
	.align	4
$$semRemovedFromLockedList::
	ex	(sp),iy
$semRemovedFromLockedList::
	.debug	G $semRemovedFromLockedList 48 9
	.debug	{ $semRemovedFromLockedList 48 415 @78 @77
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A node 5 41
;417   WaitQueue  *blocked;
	.debug	L blocked -2 36
;418   sem_t  *sem = (sem_t *)node->obj;
	.debug	L sem -4 33
	.debug	# 418
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
	.seg	FARCODE
;419   #ifdef SEM_DEBUG
;423 
;424 
;425   if (INVALID(sem_t, sem) OR !sem->inUse)  { errno = EINVAL;  return; }
	.debug	# 425
	ld	hl,@4+106
	push	hl
	ld	hl,@4+15
	push	hl
	ld	hl,(ix-4)
	ld	e,0x14
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-4)
	push	hl
	lcall	$ValidatePtr
	add	sp,8
	bool	hl
	jr	nz,@79
	ld	hl,(ix-4)
	ld	de,0x11
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@80
@79:
@81:
	.debug	< @81 @82
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
	jr	@295
@82:
	.debug	>
;426 
;427   blocked = &sem->blocked;
@80:
	.debug	# 427
	ld	hl,(ix-4)
	ld	de,0xc
	add	hl,de
	ld	(ix-2),hl
;428 
;429   #ifdef SEM_DEBUG
;433 
;434 //--- If no blocked tasks, increment the semaphore value ---
;435   if (!waitqueue_active(blocked))  {
	.debug	# 435
	ex	de,hl
	ld	h,d
	ld	l,e
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	ld	hl,0
	jr	nz,@83
	inc	l
@83:
	bool	hl
	ld	l,h
	jr	nz,@84
	inc	l
@84:
	bool	hl
	jr	nz,@85
;436     #ifdef SEM_DEBUG
;439     ++sem->value;  return;
@86:
	.debug	< @86 @87
	.debug	# 439
	ld	hl,(ix-4)
	ld	de,0x12
	add	hl,de
	push	hl
	ld	hl,(hl)
	inc	hl
	pop	de
	ex	de,hl
@295:
	ld	(hl),e
	inc	hl
	ld	(hl),d
;440   }
	jr	@77
@87:
	.debug	>
;441 
;442 //--- Otherwise move the node for the first blocked task from the blocked -
;443 //--- list to the locked list.  Note that we add the node to the end of ---
;444 //--- locked list because the unblocked task will call nodeInQList() to ---
;445 //--- see if it has the lock, and nodeInQList() is very fast if the node --
;446 //--- is at the end of the queue. ---
;447 
;448 //--- Also note that we are no longer working with the node that was passed
;449 //--- to use (which will most likely be free up in a moment) ---
;450 
;451   node = __first_task(blocked);
@85:
	.debug	# 451
	ld	hl,(ix-2)
	ld	hl,(hl)
	ld	de,0xfff8
	add	hl,de
	ld	(ix+5),hl
;452 
;453   #ifdef SEM_DEBUG
;458   __removeWaitQueue(blocked, node);
	.debug	# 458
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$__removeWaitQueue
	add	sp,4
;459 
;460   node->removeFunc = semRemovedFromLockedList;
	.debug	# 460
	ld	hl,(ix+5)
	ld	de,0x6
	add	hl,de
	ld	de,_semRemovedFromLockedList
	ld	(hl),e
	inc	hl
	ld	(hl),d
;461   __add_wait_queue_tail(&sem->locked, node);
	.debug	# 461
	ld	hl,(ix+5)
	push	hl
	ld	hl,(ix-4)
	ld	de,0x8
	add	hl,de
	push	hl
	lcall	$__add_wait_queue_tail
	add	sp,4
;462 
;463   node->task->state = TASK_RUNNING;
	.debug	# 463
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	de,0x13
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
;464 
;465   #ifdef SEM_DEBUG
;469 }
@77:
	.debug	} @77 469

@76	equ	4
	ld	sp,ix
	pop	ix
	lret
@78	equ	6
;470 
;471 
;472 
;473 //-------------------------------------------------------------------------
;474 //  Initialize the static array of semaphores
;475 //-------------------------------------------------------------------------
;476 void  initSemaphores(void)
;477 {
$initSemaphores::
	.debug	G $initSemaphores 49 9
	.debug	{ $initSemaphores 49 476 @90 @89
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
;478   uint  u;
	.debug	L u -2 7
;479   sem_t  *sem;
	.debug	L sem -4 33
;480 
;481 
;482   BZERO(semaphores);
	.debug	# 482
	ld	hl,0x160
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_semaphores
	push	hl
	call	_memset
	add	sp,6
;483 
;484   for (u=0,sem=semaphores; u<MAX_NUM_SEMS; ++u,++sem)  {
@91:
	.debug	< @91 @92
	.debug	# 484
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	hl,_semaphores
	ld	(ix-4),hl
@93:
	ld	hl,(ix-2)
	ld	de,0x10
	or	a,a
	sbc	hl,de
	jr	nc,@94
;485     init_waitqueue_head(&sem->opened);
@96:
	.debug	< @96 @97
	.debug	# 485
	ld	hl,(ix-4)
	ld	e,0x4
	add	hl,de
	push	hl
	lcall	$init_waitqueue_head
	pop	hl
;486     init_waitqueue_head(&sem->locked);
	.debug	# 486
	ld	hl,(ix-4)
	ld	de,0x8
	add	hl,de
	push	hl
	lcall	$init_waitqueue_head
	pop	hl
;487     init_waitqueue_head(&sem->blocked);
	.debug	# 487
	ld	hl,(ix-4)
	ld	de,0xc
	add	hl,de
	push	hl
	lcall	$init_waitqueue_head
	pop	hl
;488     sem->name = names[u];
	.debug	# 488
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _names)
	ld	c,phys _names >> 16
	call	__ladd##
	ld	hl,(ix-4)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;489     sem->myAddr = sem;
	.debug	# 489
	ld	hl,(ix-4)
	ld	de,0x14
	add	hl,de
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;490   }
@97:
	.debug	>
;491 
;492 }
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	h,d
	ld	l,e
	ld	de,0x16
	add	hl,de
	ld	(ix-4),hl
	jr	@93
@94:
@92:
	.debug	>
@89:
	.debug	} @89 492

@88	equ	4
	ld	sp,ix
	pop	ix
	lret
@90	equ	6
;493 
;494 //-------------------------------------------------------------------------
;495 //  Get the total and free counts for the global pool of named semaphores.
;496 //  The *ttl is set to the total, and the free count is the return value.
;497 //-------------------------------------------------------------------------
;498 uint semCounts(uint *ttl)
;499 {
	.align	4
$$semCounts::
	ex	(sp),iy
$semCounts::
	.debug	G $semCounts 50 9
	.debug	{ $semCounts 50 498 @100 @99
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A ttl 5 51
;500   uint  u, freeCount = 0;
	.debug	L u -2 7
	.debug	L freeCount -4 7
	.debug	# 500
	bool	hl
	ld	l,h
	ld	(ix-4),hl
	.seg	FARCODE
;501   sem_t  *sem;
	.debug	L sem -6 33
;502 
;503 
;504   KLOCK();
	.debug	# 504
	call	_KLOCK
;505   for (u=0,sem=semaphores; u<MAX_NUM_SEMS; ++u,++sem)
@101:
	.debug	< @101 @102
	.debug	# 505
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	hl,_semaphores
	ld	(ix-6),hl
@103:
	ld	hl,(ix-2)
	ld	de,0x10
	or	a,a
	sbc	hl,de
	jr	nc,@104
;506     if (!sem->inUse)  ++freeCount;
	.debug	# 506
	ld	hl,(ix-6)
	inc	e
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@106
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
;507   KUNLOCK();
@106:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-6)
	ld	de,0x16
	add	hl,de
	ld	(ix-6),hl
	jr	@103
@104:
@102:
	.debug	>
	.debug	# 507
	call	_KUNLOCK
;508 
;509   *ttl = MAX_NUM_SEMS;
	.debug	# 509
	ld	hl,0x10
	ex	de,hl
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;510 
;511   return freeCount;
	.debug	# 511
	ld	hl,(ix-4)
;512 }
@99:
	.debug	} @99 512

@98	equ	6
	ld	sp,ix
	pop	ix
	lret
@100	equ	8
;513 
;514 
;515 
;516 //-------------------------------------------------------------------------
;517 //  Return a pointer to the requested named semaphore.
;518 //
;519 //  If the requested semaphore exists and sem_unlink() has not been called
;520 //  for it, a pointer to the semaphore is returned.  Otherwise NULL is
;521 //  returned.
;522 //
;523 //  If an active semaphore with the specified name does not exist, and the
;524 //  unused argument is not NULL, then *unused is set to the address of an
;525 //  unused semaphore (if one exists).
;526 //
;527 //  Locking must be handled by caller.
;528 //-------------------------------------------------------------------------
;529 sem_t *getNamedSemaphore(const char *name, sem_t **unused)
;530 {
$getNamedSemaphore::
	.debug	G $getNamedSemaphore 52 9
	.debug	{ $getNamedSemaphore 52 529 @109 @108
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A name 5 53
	.debug	A unused 7 54
;531   uint  u;
	.debug	L u -2 7
;532   sem_t  *sem;
	.debug	L sem -4 33
;533 
;534 
;535   if (unused)  *unused = NULL;
	.debug	# 535
	ld	hl,(ix+7)
	bool	hl
	jr	z,@110
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;536 
;537 //===== scan the list of semaphores looking for a match and an unused one =
;538   for (u=0,sem=semaphores; u<MAX_NUM_SEMS; ++u,++sem)  {
@110:
@111:
	.debug	< @111 @112
	.debug	# 538
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	hl,_semaphores
	ld	(ix-4),hl
@113:
	ld	hl,(ix-2)
	ld	de,0x10
	or	a,a
	sbc	hl,de
	jp	nc,@114
;539     if (INVALID(sem_t, sem))  { errno = EBADSTRUCT;  return NULL; }
@116:
	.debug	< @116 @117
	.debug	# 539
	ld	hl,@4+131
	push	hl
	ld	hl,@4+15
	push	hl
	ld	hl,(ix-4)
	ld	e,0x14
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-4)
	push	hl
	lcall	$ValidatePtr
	add	sp,8
	bool	hl
	jr	z,@118
@119:
	.debug	< @119 @120
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x7c
	ld	(hl),e
	inc	hl
	ld	(hl),d
	bool	hl
	ld	l,h
	jr	@108
@120:
	.debug	>
;540 
;541     if (!sem->inUse)  { if (unused)  *unused = sem;  continue; }
@118:
	.debug	# 541
	ld	hl,(ix-4)
	ld	de,0x11
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@121
@122:
	.debug	< @122 @123
	ld	hl,(ix+7)
	bool	hl
	jr	z,@115
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@115
@123:
	.debug	>
;542 
;543     if (sem->unlinked)  continue;  // unlinked ones are inaccessible
@121:
	.debug	# 543
	ld	hl,(ix-4)
	ld	de,0x10
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@115
;544 
;545     if (fstrcmp(name, sem->name))  continue;  // different name?
	.debug	# 545
	ld	hl,(ix-4)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fstrcmp
	add	sp,8
	bool	hl
	jr	nz,@115
;546 
;547     return sem;
	.debug	# 547
	ld	hl,(ix-4)
	jr	@108
;548   }
@117:
	.debug	>
;549 
;550   return NULL;
@115:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-4)
	ld	de,0x16
	add	hl,de
	ld	(ix-4),hl
	jp	@113
@114:
@112:
	.debug	>
	.debug	# 550
	bool	hl
	ld	l,h
;551 }
@108:
	.debug	} @108 551

@107	equ	4
	ld	sp,ix
	pop	ix
	lret
@109	equ	6
;552 
;553 
;554 //==================== The standard POSIX style functions =================
;555 
;556 //-------------------------------------------------------------------------
;557 //  Create a connection to a named semaphore
;558 //
;559 //  Arguments:
;560 //    name:   Name to use for a new semaphore or the name of an existing
;561 //            semaphore
;562 //    oflag:  Specifies open mode:  O_CREAT alone means create the semaphor
;563 //            if it doesn't already exist.  O_CREAT | O_EXCL means return
;564 //            and error if the semaphore already exists.
;565 //    mode:   Traditional mask of access rights (currently ignored)
;566 //    value:  Initial value for new semaphores.
;567 //
;568 //  Returns a pointer to the requested semaphore, or NULL if an error (with
;569 //  errno set to indicate the error)
;570 //-------------------------------------------------------------------------
;571 sem_t *sem_open(const char *name, int oflag, mode_t mode, uint value)
;572 {
$sem_open::
	.debug	G $sem_open 55 9
	.debug	{ $sem_open 55 571 @129 @128
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	.debug	A name 5 53
	.debug	A oflag 7 6
	.debug	A mode 9 9
	.debug	A value 13 7
;573   sem_t  *sem, *unused = NULL;
	.debug	L sem -2 33
	.debug	L unused -4 33
	.debug	# 573
	bool	hl
	ld	l,h
	ld	(ix-4),hl
	.seg	FARCODE
;574   uint  len;
	.debug	L len -6 7
;575   WaitQueueNode  *node;
	.debug	L node -8 41
;576 
;577 
;578   oflag &= (O_CREAT | O_EXCL);
	.debug	# 578
	ld	hl,(ix+7)
	ld	de,0x44
	and	hl,de
	ld	(ix+7),hl
;579 
;580   KLOCK();
	.debug	# 580
	call	_KLOCK
;581 
;582   sem = getNamedSemaphore(name, &unused);
	.debug	# 582
	ld	hl,-4+@127
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$getNamedSemaphore
	add	sp,4
	ld	(ix-2),hl
;583 
;584   if (sem)  {
	.debug	# 584
	bool	hl
	jr	z,@130
;585   //--- error if caller expected to create a new one and it already exists 
;586     if (oflag == (O_CREAT | O_EXCL))  {
@131:
	.debug	< @131 @132
	.debug	# 586
	ld	hl,(ix+7)
	ld	de,0x44
	or	a,a
	sbc	hl,de
	jr	nz,@133
;587       KUNLOCK();  errno = EEXIST;  return SEM_FAILED; }
@134:
	.debug	< @134 @135
	.debug	# 587
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x11
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@294
@135:
	.debug	>
;588 
;589   //--- If caller already in the semaphore's 'opened' list, we are done ---
;590     if (taskInQList(&sem->opened, current))  { KUNLOCK();  return sem; }
@133:
	.debug	# 590
	ld	hl,(_current)
	push	hl
	ld	hl,(ix-2)
	ld	de,0x4
	add	hl,de
	push	hl
	lcall	$taskInQList
	add	sp,4
	bool	hl
	jr	nz,@293
@137:
	.debug	< @137 @138
@138:
	.debug	>
;591 
;592   //--- try to add the caller to the semaphore's 'opened' list ---
;593     if (!(node = alloc_WaitQueueNode()))  { KUNLOCK();  return NULL; }
	.debug	# 593
	lcall	$alloc_WaitQueueNode
	ld	(ix-8),hl
	bool	hl
	jr	nz,@139
@140:
	.debug	< @140 @141
	call	_KUNLOCK
@294:
	bool	hl
	ld	l,h
	jp	@128
@141:
	.debug	>
;594 
;595     node->obj = sem;  node->removeFunc = semRemovedFromOpenList;
@139:
	.debug	# 595
	ld	hl,(ix-8)
	ld	de,0x4
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-8)
	ld	de,0x6
	add	hl,de
	ld	de,_semRemovedFromOpenList
	ld	(hl),e
	inc	hl
	ld	(hl),d
;596     __add_wait_queue_tail(&sem->opened, node);
	.debug	# 596
	ld	hl,(ix-8)
	push	hl
	ld	hl,(ix-2)
	ld	de,0x4
	add	hl,de
	push	hl
	lcall	$__add_wait_queue_tail
	add	sp,4
;597 
;598     KUNLOCK();
	.debug	# 598
@293:
	call	_KUNLOCK
;599 
;600     #ifdef SEM_DEBUG
;604     return sem;
	.debug	# 604
	ld	hl,(ix-2)
	jp	@128
;605   }
@132:
	.debug	>
;606 
;607 //===== No match, so create a new one if requested =====
;608   do  {
@130:
;609     sem = NULL;
@145:
	.debug	< @145 @146
	.debug	# 609
	bool	hl
	ld	l,h
	ld	(ix-2),hl
;610 
;611   //--- doesn't exist and caller did not request to create it ---
;612     if (!(oflag & O_CREAT))  { errno = ENOENT;  break; }
	.debug	# 612
	ld	hl,(ix+7)
	ld	de,0x4
	and	hl,de
	jr	nz,@147
@148:
	.debug	< @148 @149
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
	ld	e,0x2
	jr	@292
@149:
	.debug	>
;613 
;614   //--- name too long or empty? ---
;615     len = strlen(name);
@147:
	.debug	# 615
	ld	hl,(ix+5)
	push	hl
	call	_strlen
	pop	de
	ld	(ix-6),hl
;616     if (len > NAME_MAX)  { errno = ENAMETOOLONG;  break; }
	.debug	# 616
	ld	de,0x18
	or	a,a
	sbc	hl,de
	jr	c,@150
	jr	z,@150
@151:
	.debug	< @151 @152
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
	ld	e,0x24
	jr	@292
@152:
	.debug	>
;617     if (len < 1)  { errno = EINVAL;  break; }
@150:
	.debug	# 617
	ld	hl,(ix-6)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nc,@153
@154:
	.debug	< @154 @155
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
	ld	e,0x16
	jr	@292
@155:
	.debug	>
;618 
;619   //--- do we have the resources to create a new semaphore? ---
;620     if (!unused)  { errno = ENFILE;  break; }
@153:
	.debug	# 620
	ld	hl,(ix-4)
	bool	hl
	jr	nz,@156
@157:
	.debug	< @157 @158
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x17
@292:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@143
@158:
	.debug	>
;621     if (!(node = alloc_WaitQueueNode()))  break;
@156:
	.debug	# 621
	lcall	$alloc_WaitQueueNode
	ld	(ix-8),hl
	bool	hl
	jr	z,@143
;622 
;623     sem = unused;
	.debug	# 623
	ld	hl,(ix-4)
	ld	(ix-2),hl
;624 
;625     node->obj = sem;  node->removeFunc = semRemovedFromOpenList;
	.debug	# 625
	ld	hl,(ix-8)
	ld	de,0x4
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-8)
	ld	de,0x6
	add	hl,de
	ld	de,_semRemovedFromOpenList
	ld	(hl),e
	inc	hl
	ld	(hl),d
;626     __add_wait_queue_tail(&sem->opened, node);
	.debug	# 626
	ld	hl,(ix-8)
	push	hl
	ld	hl,(ix-2)
	ld	de,0x4
	add	hl,de
	push	hl
	lcall	$__add_wait_queue_tail
	add	sp,4
;627 
;628     fstrcpy(sem->name, name);
	.debug	# 628
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-2)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;629     sem->value = value;  sem->inUse = true;
	.debug	# 629
	ld	hl,(ix-2)
	ld	de,0x12
	add	hl,de
	ex	de,hl
	ld	hl,(ix+13)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-2)
	ld	de,0x11
	add	hl,de
	ld	a,0x1
	ld	(hl),a
;630   }  while(0);
@146:
	.debug	>
	.debug	# 630
;631 
;632 
;633   KUNLOCK();
@143:
	.debug	# 633
	call	_KUNLOCK
;634 
;635   #ifdef SEM_DEBUG
;639   return sem;
	.debug	# 639
	ld	hl,(ix-2)
;640 }
@128:
	.debug	} @128 640

@127	equ	8
	ld	sp,ix
	pop	ix
	lret
@129	equ	10
;641 
;642 
;643 //-------------------------------------------------------------------------
;644 //  Initialize an unnamed semaphore
;645 //
;646 //  Arguments:
;647 //    sem:      ptr to sem_t variable accessible to all tasks that will use
;648 //    pshared:  true if other tasks should be able to use the semaphore
;649 //    value:    Initial value for the semaphore
;650 //
;651 //  Returns 0 on success, -1 if an error (with errno set to indicate the er
;652 //-------------------------------------------------------------------------
;653 int sem_init(sem_t *sem, int pshared, uint value)
;654 {
$sem_init::
	.debug	G $sem_init 56 9
	.debug	{ $sem_init 56 653 @162 @161
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A sem 5 33
	.debug	A pshared 7 6
	.debug	A value 9 7
;655 #define  ADDR  ((ulong)sem)
;656 
;657 
;658 //--- shared ones must be in global memory where other tasks can access the
;659   if (pshared)
	.debug	# 659
	ld	hl,(ix+7)
	bool	hl
	jr	z,@163
;660     if (! ( ((ADDR >= dataStart) AND (ADDR <= dataEnd))
;661          OR ((ADDR >= bssStart)  AND (ADDR <= bssEnd)) ) )  {
	.debug	# 661
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	ld	hl,(_dataStart)
	push	bc
	push	de
	ex	de,hl
	call	__lsub##
	jr	c,@165
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	ld	hl,(_dataEnd)
	push	bc
	push	de
	ex	de,hl
	call	__lsub##
	jr	z,@174
	jr	c,@174
@165:
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	ld	hl,(_bssStart)
	push	bc
	push	de
	ex	de,hl
	call	__lsub##
	jr	c,@168
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	ld	hl,(_bssEnd)
	push	bc
	push	de
	ex	de,hl
	call	__lsub##
	jr	z,@174
	jr	c,@174
@168:
;662       errno = EFAULT;  return -1;
@175:
	.debug	< @175 @176
	.debug	# 662
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xe
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@161
;663     }
@176:
	.debug	>
;664 
;665   if (sem->inUse)
@174:
@163:
	.debug	# 665
	ld	hl,(ix+5)
	ld	de,0x11
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@177
;666     fprintf(DiagLog, "***** sem_init() on inUse semaphore! *****\n");
	.debug	# 666
	ld	hl,@4+149
	push	hl
	ld	hl,_diagLog
	push	hl
	lcall	$fprintf
	add	sp,4
;667 
;668 #ifdef SEM_DEBUG
;672   KLOCK();
@177:
	.debug	# 672
	call	_KLOCK
;673 
;674   BZERO(sem);
	.debug	# 674
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+5)
	push	hl
	call	_memset
	add	sp,6
;675 
;676   init_waitqueue_head(&sem->opened);
	.debug	# 676
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	push	hl
	lcall	$init_waitqueue_head
	pop	hl
;677   init_waitqueue_head(&sem->locked);
	.debug	# 677
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	push	hl
	lcall	$init_waitqueue_head
	pop	hl
;678   init_waitqueue_head(&sem->blocked);
	.debug	# 678
	ld	hl,(ix+5)
	ld	de,0xc
	add	hl,de
	push	hl
	lcall	$init_waitqueue_head
	pop	hl
;679 
;680   sem->myAddr = sem;
	.debug	# 680
	ld	hl,(ix+5)
	ld	de,0x14
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;681 
;682   sem->value = value;  sem->inUse = true;
	.debug	# 682
	ld	h,d
	ld	l,e
	ld	de,0x12
	add	hl,de
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix+5)
	ld	de,0x11
	add	hl,de
	ld	a,0x1
	ld	(hl),a
;683 
;684   KUNLOCK();
	.debug	# 684
	call	_KUNLOCK
;685 
;686   return 0;
	.debug	# 686
	bool	hl
	ld	l,h
;687 }
@161:
	.debug	} @161 687

@160	equ	0
	pop	ix
	lret
@162	equ	2
;688 
;689 
;690 //-------------------------------------------------------------------------
;691 //  Close the connection between a task and a named semaphore.
;692 //
;693 //  If the caller has an open connection to the semaphore, then release any
;694 //  of the locks it may have and close the connection.  If unlink was calle
;695 //  for the semaphore, then it cannot be opened again, and when the last
;696 //  open connection to it is closed it will be destroyed.
;697 //
;698 //  Returns 0 on success, -1 if an error (with errno set to indicate the er
;699 //-------------------------------------------------------------------------
;700 int sem_close(sem_t *sem)
;701 {
$sem_close::
	.debug	G $sem_close 57 9
	.debug	{ $sem_close 57 700 @180 @179
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A sem 5 33
;702   int  stat = -1;
	.debug	L stat -2 6
	.debug	# 702
	ld	hl,0xffff
	ld	(ix-2),hl
	.seg	FARCODE
;703   WaitQueueNode  *node;
	.debug	L node -4 41
;704   WaitQueue  *opened;
	.debug	L opened -6 36
;705 
;706 
;707   KLOCK();
	.debug	# 707
	call	_KLOCK
;708 
;709   do  {
;710     if (!namedSemaphore(sem))  { errno = EINVAL;  break; }
@184:
	.debug	< @184 @185
	.debug	# 710
	ld	hl,(ix+5)
	push	hl
	lcall	$namedSemaphore
	pop	hl
	or	a,a
	jr	nz,@186
@187:
	.debug	< @187 @188
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
	jr	@291
@188:
	.debug	>
;711 
;712     opened = &sem->opened;
@186:
	.debug	# 712
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	(ix-6),hl
;713 
;714   //--- does the caller have an open connection to the semaphore? ---
;715     if (! (node = taskInQList(opened, current)))  { errno = ENOLINK;  break
	.debug	# 715
	ld	hl,(_current)
	push	hl
	ld	hl,(ix-6)
	push	hl
	lcall	$taskInQList
	add	sp,4
	ld	(ix-4),hl
	bool	hl
	jr	nz,@189
@190:
	.debug	< @190 @191
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x43
@291:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@182
@191:
	.debug	>
;716 
;717   //--- Remove the task from the list of those that have the semaphore open
;718   //--- Note that the removal of the node from the opened list will cause -
;719   //--- semRemovedFromOpenList() to be called, which will free up any locks
;720   //--- the task may have on the semaphore and free up the semaphore if it 
;721   //--- was unlinked and has no more open connections ---
;722     __removeWaitQueue(opened, node);  free_WaitQueueNode(node);
@189:
	.debug	# 722
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix-6)
	push	hl
	lcall	$__removeWaitQueue
	add	sp,4
	ld	hl,(ix-4)
	push	hl
	lcall	$free_WaitQueueNode
	pop	hl
;723 
;724     stat = 0;
	.debug	# 724
	bool	hl
	ld	l,h
	ld	(ix-2),hl
;725   } while(0);
@185:
	.debug	>
	.debug	# 725
;726 
;727   KUNLOCK();
@182:
	.debug	# 727
	call	_KUNLOCK
;728 
;729   #ifdef SEM_DEBUG
;733   return stat;
	.debug	# 733
	ld	hl,(ix-2)
;734 }
@179:
	.debug	} @179 734

@178	equ	6
	ld	sp,ix
	pop	ix
	lret
@180	equ	8
;735 
;736 
;737 //-------------------------------------------------------------------------
;738 //  Attempt to get a lock on a semaphore, blocking up to the specified numb
;739 //  of "jiffies" (scheduler ticks) before giving up.  A timeout of 0 means
;740 //  return right away if no lock is available, while MAX_SCHEDULE_TIMEOUT m
;741 //  block indefinitely.  In any case, the function may return without a loc
;742 //  if it was interrupted by a signal.
;743 //
;744 //  Returns 0 on success, -1 if an error (with errno set to indicate the er
;745 //-------------------------------------------------------------------------
;746 //  NOTE:  sem_wait() is a macro that calls this with MAX_SCHEDULE_TIMEOUT
;747 //-------------------------------------------------------------------------
;748 int sem_wait_(sem_t *sem, ulong timeoutTicks)
;749 {
$sem_wait_::
	.debug	G $sem_wait_ 58 9
	.debug	{ $sem_wait_ 58 748 @194 @193
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A sem 5 33
	.debug	A timeoutTicks 7 9
;750   int  stat = -1;
	.debug	L stat -2 6
	.debug	# 750
	ld	hl,0xffff
	ld	(ix-2),hl
	.seg	FARCODE
;751   WaitQueueNode *node;
	.debug	L node -4 41
;752 
;753 
;754   do  {
;755     KLOCK();
@198:
	.debug	< @198 @199
	.debug	# 755
	call	_KLOCK
;756 
;757   //--- valid semaphore? ---
;758     if (INVALID(sem_t, sem) OR !sem->inUse)  {
	.debug	# 758
	ld	hl,@4+193
	push	hl
	ld	hl,@4+15
	push	hl
	ld	hl,(ix+5)
	ld	de,0x14
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$ValidatePtr
	add	sp,8
	bool	hl
	jr	nz,@200
	ld	hl,(ix+5)
	ld	de,0x11
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@201
@200:
;759       KUNLOCK();  errno = EINVAL;  break; }
@202:
	.debug	< @202 @203
	.debug	# 759
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
	jp	@290
@203:
	.debug	>
;760 
;761   //--- if a named semaphore, does the task have an open connection? ---
;762     if (sem->name)  if (! (node = taskInQList(&sem->opened, current)))  {
@201:
	.debug	# 762
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@204
	ld	hl,(_current)
	push	hl
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	push	hl
	lcall	$taskInQList
	add	sp,4
	ld	(ix-4),hl
	bool	hl
	jr	nz,@205
;763       KUNLOCK();  errno = ENOLINK;  break; }
@206:
	.debug	< @206 @207
	.debug	# 763
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x43
	jp	@290
@207:
	.debug	>
;764 
;765   //--- no locks available and blocking not requested? ---
;766     if (!sem->value AND !timeoutTicks)  {
@205:
@204:
	.debug	# 766
	ld	hl,(ix+5)
	ld	de,0x12
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	nz,@209
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	or	hl,de
	jr	nz,@209
;767       KUNLOCK();  errno = EAGAIN;  break; }
@210:
	.debug	< @210 @211
	.debug	# 767
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xb
	jp	@290
@211:
	.debug	>
;768 
;769   //--- allocate a node to use in the locked or blocked list ---
;770     if (!(node = alloc_WaitQueueNode()))  { KUNLOCK();  break; }
@209:
	.debug	# 770
	lcall	$alloc_WaitQueueNode
	ld	(ix-4),hl
	bool	hl
	jr	nz,@212
@213:
	.debug	< @213 @214
	call	_KUNLOCK
	jp	@196
@214:
	.debug	>
;771     node->obj = sem;
@212:
	.debug	# 771
	ld	hl,(ix-4)
	ld	de,0x4
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;772 
;773   //--- lock available, so take it ---
;774     if (sem->value)  {
	.debug	# 774
	ld	h,d
	ld	l,e
	ld	de,0x12
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	z,@215
;775       node->removeFunc = semRemovedFromLockedList;
@216:
	.debug	< @216 @217
	.debug	# 775
	ld	hl,(ix-4)
	ld	e,0x6
	add	hl,de
	ld	de,_semRemovedFromLockedList
	ld	(hl),e
	inc	hl
	ld	(hl),d
;776       __add_wait_queue_tail(&sem->locked, node);  --sem->value;
	.debug	# 776
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	push	hl
	lcall	$__add_wait_queue_tail
	add	sp,4
	ld	hl,(ix+5)
	ld	de,0x12
	add	hl,de
	push	hl
	ld	hl,(hl)
	dec	hl
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;777       KUNLOCK();
	.debug	# 777
	call	_KUNLOCK
;778       #ifdef SEM_DEBUG
;781       stat = 0;  break;
	.debug	# 781
	bool	hl
	ld	l,h
	ld	(ix-2),hl
;782     }
	jp	@196
@217:
	.debug	>
;783 
;784 
;785   //--- no lock available, so block waiting for it ---
;786     __add_wait_queue_tail(&sem->blocked, node);
@215:
	.debug	# 786
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix+5)
	ld	de,0xc
	add	hl,de
	push	hl
	lcall	$__add_wait_queue_tail
	add	sp,4
;787     __set_current_state(TASK_INTERRUPTIBLE);
@221:
	.debug	< @221 @222
	.debug	# 787
	ld	hl,(_current)
	ld	de,0x13
	add	hl,de
	ld	e,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
@222:
	.debug	>
;788 
;789     KUNLOCK();
	.debug	# 789
	call	_KUNLOCK
;790 
;791     #ifdef SEM_DEBUG
;795     timeoutTicks = schedule_timeout(timeoutTicks);
	.debug	# 795
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	lcall	$schedule_timeout
	add	sp,4
	ld	hl,bc
	ld	(ix+9),hl
	ex	de,hl
	ld	(ix+7),hl
	ex	de,hl
;796 
;797     KLOCK();
	.debug	# 797
	call	_KLOCK
;798 
;799   //--- We were woken up either because of a signal or because a lock was -
;800   //--- given to us when another task's lock was released ---
;801 
;802   //--- If we got the lock, then the node we put in to the blocked list was
;803   //--- moved to the locked list by semRemovedFromLockedList().  Otherwise,
;804   //--- we were woken by a signal and we need to remove the node from the -
;805   //--- blocked list, free it, and (possibly) try again. ---
;806 
;807     if (! nodeInQList(&sem->locked, node))  {
	.debug	# 807
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	push	hl
	lcall	$nodeInQList
	add	sp,4
	or	a,a
	jr	nz,@223
;808       __removeWaitQueue(&sem->blocked, node);  free_WaitQueueNode(node);
@224:
	.debug	< @224 @225
	.debug	# 808
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix+5)
	ld	de,0xc
	add	hl,de
	push	hl
	lcall	$__removeWaitQueue
	add	sp,4
	ld	hl,(ix-4)
	push	hl
	lcall	$free_WaitQueueNode
	pop	hl
;809       // if timeout elapsed, return an error
;810       if (!timeoutTicks)  { KUNLOCK();  errno = ETIMEDOUT;  break; }
	.debug	# 810
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	or	hl,de
	jr	nz,@226
@227:
	.debug	< @227 @228
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x6e
	jr	@290
@228:
	.debug	>
;811       // if still some ticks left, try again...
;812       if (timeoutTicks != MAX_SCHEDULE_TIMEOUT)  { KUNLOCK();  continue; }
@226:
	.debug	# 812
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1
	ld	bc,0x8000
	call	__ladd##
	jr	z,@229
@230:
	.debug	< @230 @231
	call	_KUNLOCK
	jr	@197
@231:
	.debug	>
;813       // No timeout was given, and we didn't get the lock, so we must have
;814       // been woken for some other reason.
;815       errno = EINTR;  break;
@229:
	.debug	# 815
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x4
@290:
	ld	(hl),e
	inc	hl
	ld	(hl),d
;816     }
	jr	@196
@225:
	.debug	>
;817 
;818     KUNLOCK();
@223:
	.debug	# 818
	call	_KUNLOCK
;819 
;820   //--- we have a lock! ---
;821     stat = 0;
	.debug	# 821
	bool	hl
	ld	l,h
	ld	(ix-2),hl
;822 
;823   #ifdef SEM_DEBUG
;827   } while(0);
@199:
	.debug	>
@197:
	.debug	# 827
;828 
;829   return stat;
@196:
	.debug	# 829
	ld	hl,(ix-2)
;830 }
@193:
	.debug	} @193 830

@192	equ	4
	ld	sp,ix
	pop	ix
	lret
@194	equ	6
;831 
;832 
;833 //-------------------------------------------------------------------------
;834 //  Attempt to get a lock on a semaphore, blocking if necessary until a
;835 //  specified time.
;836 //
;837 //  NOTE:  It is generally much more efficient to simply do this:
;838 //
;839 //            sem_wait_(sem, msToTicks(ms));
;840 //
;841 //         which avoids all the math for computing a timeoutTicks value fro
;842 //         a timespec value (msToTicks() does some, but MUCH less then here
;843 //
;844 //         While sem_wait_(sem, timeoutTicks) is not a standard, it would b
;845 //         easy enough to implement on a Unix/Linux system.
;846 //
;847 //
;848 //  Returns 0 on success, -1 if an error (with errno set)
;849 //-------------------------------------------------------------------------
;850 int sem_timedwait(sem_t *sem, const struct timespec *abs_timeout)
;851 {
$sem_timedwait::
	.debug	G $sem_timedwait 59 9
	.debug	{ $sem_timedwait 59 850 @234 @233
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-30
	.debug	A sem 5 33
	.debug	A abs_timeout 7 60
;852   ulong  secs = 0;
	.debug	L secs -4 9
	.debug	# 852
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.seg	FARCODE
;853   uint  curMS, timeoutMS, ms;
	.debug	L curMS -6 7
	.debug	L timeoutMS -8 7
	.debug	L ms -10 7
;854   ulong  timeoutTicks = 0, maxSecs, ticksPerSec;
	.debug	L timeoutTicks -14 9
	.debug	# 854
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
	.seg	FARCODE
	.debug	L maxSecs -18 9
	.debug	L ticksPerSec -22 9
;855   struct timeval  tv;
	.debug	L tv -30 62
;856 
;857 
;858   gettimeofday(&tv, NULL);
	.debug	# 858
	push	hl
	ld	hl,-28+@232
	add	hl,sp
	push	hl
	lcall	$gettimeofday
	add	sp,4
;859 
;860 //--- compute interval from now to abs_timeout in "jiffies" (timer ticks) -
;861   do  {
;862     if (abs_timeout->tv_sec < tv.tv_sec)  break;
@238:
	.debug	< @238 @239
	.debug	# 862
	ld	hl,(ix+7)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-30)
	ex	de,hl
	ld	hl,(ix-28)
	ld	bc,hl
	call	__lsub##
	jp	c,@236
;863 
;864     curMS = (uint) (tv.tv_usec / 1000);
	.debug	# 864
	ld	hl,(ix-26)
	ex	de,hl
	ld	hl,(ix-24)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3e8
	ld	bc,0
	call	__ldiv##
	ex	de,hl
	ld	(ix-6),hl
;865     timeoutMS = (uint) (abs_timeout->tv_nsec / 1000000L);
	.debug	# 865
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x4240
	ld	bc,0xf
	call	__ldiv##
	ex	de,hl
	ld	(ix-8),hl
;866 
;867     if (abs_timeout->tv_sec == tv.tv_sec)  if (timeoutMS <= curMS)  break;
	.debug	# 867
	ld	hl,(ix+7)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-30)
	ex	de,hl
	ld	hl,(ix-28)
	ld	bc,hl
	call	__lsub##
	jr	nz,@241
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@243
	jr	nc,@242
@243:
;868 
;869     ticksPerSec = msToTicks(1000);  maxSecs = ULONG_MAX / ticksPerSec - 1;
	jp	@236
@242:
@241:
	.debug	# 869
	ld	de,0x3e8
	ld	bc,0
	push	bc
	push	de
	lcall	$msToTicks
	add	sp,4
	ld	hl,bc
	ld	(ix-20),hl
	ex	de,hl
	ld	(ix-22),hl
	ex	de,hl
	ld	de,0xffff
	ld	c,e
	ld	b,e
	push	bc
	push	de
	ld	hl,(ix-22)
	ex	de,hl
	ld	hl,(ix-20)
	ld	bc,hl
	call	__uldiv##
	call	__ldec##
	ld	hl,bc
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-18),hl
	ex	de,hl
;870 
;871     secs = abs_timeout->tv_sec - tv.tv_sec;
	.debug	# 871
	ld	hl,(ix+7)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-30)
	ex	de,hl
	ld	hl,(ix-28)
	ld	bc,hl
	call	__lsub##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;872     if (secs > maxSecs)  secs = maxSecs;
	.debug	# 872
	push	bc
	push	de
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	call	__lsub##
	jr	c,@244
	jr	z,@244
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;873 
;874     ms = timeoutMS - curMS;
@244:
	.debug	# 874
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix-10),hl
;875 
;876     timeoutTicks = secs * ticksPerSec + msToTicks(ms);
	.debug	# 876
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	lcall	$msToTicks
	add	sp,4
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-22)
	ex	de,hl
	ld	hl,(ix-20)
	ld	bc,hl
	call	__ulmlt##
	call	__ladd##
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;877   }  while (0);
@239:
	.debug	>
	.debug	# 877
;878 
;879 
;880   return sem_wait_(sem, timeoutTicks);
@236:
	.debug	# 880
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$sem_wait_
	add	sp,6
;881 }
@233:
	.debug	} @233 881

@232	equ	30
	ld	sp,ix
	pop	ix
	lret
@234	equ	32
;882 
;883 
;884 //-------------------------------------------------------------------------
;885 //  Get a lock on a semaphore if it can be obtained witout blocking.
;886 //
;887 //  Returns 0 on success, -1 if not (errno == EAGAIN if no errors, but all
;888 //  locks in use).
;889 //-------------------------------------------------------------------------
;890 int sem_trywait(sem_t *sem)
;891 {
$sem_trywait::
	.debug	G $sem_trywait 57 9
	.debug	{ $sem_trywait 57 890 @247 @246
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A sem 5 33
;892   return sem_wait_(sem, 0);
	.debug	# 892
	ld	de,0
	ld	c,e
	ld	b,e
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$sem_wait_
	add	sp,6
;893 }
@246:
	.debug	} @246 893

@245	equ	0
	pop	ix
	lret
@247	equ	2
;894 
;895 
;896 //-------------------------------------------------------------------------
;897 //  Release a lock on a semaphore
;898 //-------------------------------------------------------------------------
;899 int sem_post(sem_t *sem)
;900 {
$sem_post::
	.debug	G $sem_post 57 9
	.debug	{ $sem_post 57 899 @250 @249
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A sem 5 33
;901   int  stat = -1;
	.debug	L stat -2 6
	.debug	# 901
	ld	hl,0xffff
	ld	(ix-2),hl
	.seg	FARCODE
;902   WaitQueueNode  *node;
	.debug	L node -4 41
;903   WaitQueue  *locked;
	.debug	L locked -6 36
;904 
;905 
;906   KLOCK();
	.debug	# 906
	call	_KLOCK
;907 
;908   do  {
;909 //    if (!namedSemaphore(sem))  { errno = EINVAL;  break; }
;910 
;911     locked = &sem->locked;
@254:
	.debug	< @254 @255
	.debug	# 911
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	(ix-6),hl
;912 
;913   //--- does the task have a lock on the semaphore? ---
;914     if (! (node = taskInQList(locked, current)))  { errno = ENOLINK;  break
	.debug	# 914
	ld	hl,(_current)
	push	hl
	ld	hl,(ix-6)
	push	hl
	lcall	$taskInQList
	add	sp,4
	ld	(ix-4),hl
	bool	hl
	jr	nz,@256
@257:
	.debug	< @257 @258
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x43
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@252
@258:
	.debug	>
;915 
;916   //--- Remove the first node in the locked list for the calling task ---
;917   //--- Note that the removal of the node in the locked list will cause ---
;918   //--- semRemovedFromLockedList() to be called, which will transfer the --
;919   //--- lock to the first blocked task (if any) and resume it ---
;920     __removeWaitQueue(locked, node);  free_WaitQueueNode(node);
@256:
	.debug	# 920
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix-6)
	push	hl
	lcall	$__removeWaitQueue
	add	sp,4
	ld	hl,(ix-4)
	push	hl
	lcall	$free_WaitQueueNode
	pop	hl
;921 
;922     stat = 0;
	.debug	# 922
	bool	hl
	ld	l,h
	ld	(ix-2),hl
;923 
;924   } while(0);
@255:
	.debug	>
	.debug	# 924
;925 
;926   KUNLOCK();
@252:
	.debug	# 926
	call	_KUNLOCK
;927 
;928   return stat;
	.debug	# 928
	ld	hl,(ix-2)
;929 }
@249:
	.debug	} @249 929

@248	equ	6
	ld	sp,ix
	pop	ix
	lret
@250	equ	8
;930 
;931 
;932 //-------------------------------------------------------------------------
;933 //  Destroy (free for future use) an unnamed semaphore that was initialized
;934 //  by an earlier call to sem_init()
;935 //
;936 //  Returns 0 on success, -1 if an error (with errno set to indicate the er
;937 //-------------------------------------------------------------------------
;938 int sem_destroy(sem_t *sem)
;939 {
$sem_destroy::
	.debug	G $sem_destroy 57 9
	.debug	{ $sem_destroy 57 938 @261 @260
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A sem 5 33
;940   WaitQueue  *blocked, *locked;
	.debug	L blocked -2 36
	.debug	L locked -4 36
;941 
;942 
;943   KLOCK();
	.debug	# 943
	call	_KLOCK
;944 
;945   if (!unnamedSemaphore(sem))  { KUNLOCK();  errno = EINVAL;  return -1; }
	.debug	# 945
	ld	hl,(ix+5)
	push	hl
	lcall	$unnamedSemaphore
	pop	hl
	or	a,a
	jr	nz,@262
@263:
	.debug	< @263 @264
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
	jr	@289
@264:
	.debug	>
;946 
;947   blocked = &sem->blocked;  locked = &sem->locked;
@262:
	.debug	# 947
	ld	hl,(ix+5)
	ld	de,0xc
	add	hl,de
	ld	(ix-2),hl
	ld	hl,(ix+5)
	ld	e,0x8
	add	hl,de
	ld	(ix-4),hl
;948 
;949   if (waitqueue_active(blocked) OR waitqueue_active(locked))  {
	.debug	# 949
	ld	hl,(ix-2)
	ex	de,hl
	ld	h,d
	ld	l,e
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	ld	hl,0
	jr	nz,@265
	inc	l
@265:
	bool	hl
	ld	l,h
	jr	nz,@266
	inc	l
@266:
	bool	hl
	jr	nz,@267
	ld	hl,(ix-4)
	ex	de,hl
	ld	h,d
	ld	l,e
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	ld	hl,0
	jr	nz,@269
	inc	l
@269:
	bool	hl
	ld	l,h
	jr	nz,@270
	inc	l
@270:
	bool	hl
	jr	z,@268
@267:
;950     KUNLOCK();  errno = EBUSY;  return -1; }
@271:
	.debug	< @271 @272
	.debug	# 950
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x10
@289:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@260
@272:
	.debug	>
;951 
;952   sem->inUse = false;
@268:
	.debug	# 952
	ld	hl,(ix+5)
	ld	de,0x11
	add	hl,de
	xor	a,a
	ld	(hl),a
;953 
;954   KUNLOCK();
	.debug	# 954
	call	_KUNLOCK
;955 
;956   #ifdef SEM_DEBUG
;960   return 0;
	.debug	# 960
	bool	hl
	ld	l,h
;961 }
@260:
	.debug	} @260 961

@259	equ	4
	ld	sp,ix
	pop	ix
	lret
@261	equ	6
;962 
;963 
;964 //-------------------------------------------------------------------------
;965 //  Get the recent state of a semaphore.
;966 //
;967 //  *sval is set to a value indicating the state of the semaphore at some t
;968 //  during the call.
;969 //
;970 //  A value of 0 or < 0 indicates there were no locks available, and the
;971 //  absolute value represents the number of tasks that were waiting for a l
;972 //
;973 //  A value > 0 indicates that a lock was available.
;974 //
;975 //  Remember that the result only represents that state the semaphore WAS i
;976 //  at some time during the call.  It is very possible the state will have
;977 //  changed before the caller even sees this result.
;978 //
;979 //  A return value of 0 indicates success and *sval was set.  A return valu
;980 //  of -1 indicates there was an error occured and the value of *sval is
;981 //  undefined.
;982 //-------------------------------------------------------------------------
;983 int sem_getvalue(sem_t *sem, int *sval)
;984 {
$sem_getvalue::
	.debug	G $sem_getvalue 63 9
	.debug	{ $sem_getvalue 63 983 @275 @274
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A sem 5 33
	.debug	A sval 7 64
;985   WaitQueue  *blocked;
	.debug	L blocked -2 36
;986 
;987 
;988   KLOCK();
	.debug	# 988
	call	_KLOCK
;989 
;990 //--- invalid pointer or corrupted semaphore? ---
;991   if (INVALID(sem_t, sem))  { KUNLOCK();  return -1; }
	.debug	# 991
	ld	hl,@4+203
	push	hl
	ld	hl,@4+15
	push	hl
	ld	hl,(ix+5)
	ld	de,0x14
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$ValidatePtr
	add	sp,8
	bool	hl
	jr	z,@276
@277:
	.debug	< @277 @278
	call	_KUNLOCK
	ld	hl,0xffff
	jr	@274
@278:
	.debug	>
;992 
;993   if (sem->value)  // locks available?
@276:
	.debug	# 993
	ld	hl,(ix+5)
	ld	de,0x12
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	z,@279
;994     *sval = sem->value;
	.debug	# 994
	ld	hl,(ix+5)
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;995   else  {
	jr	@280
@279:
;996     blocked = &sem->blocked;  *sval = qListSize(blocked);  }
@281:
	.debug	< @281 @282
	.debug	# 996
	ld	hl,(ix+5)
	ld	de,0xc
	add	hl,de
	ld	(ix-2),hl
	push	hl
	lcall	$qListSize
	pop	de
	ex	de,hl
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
@282:
	.debug	>
;997 
;998   KUNLOCK();  return 0;
@280:
	.debug	# 998
	call	_KUNLOCK
	bool	hl
	ld	l,h
;999 }
@274:
	.debug	} @274 999

@273	equ	2
	ld	sp,ix
	pop	ix
	lret
@275	equ	4
;1000 
;1001 
;1002 //-------------------------------------------------------------------------
;1003 //  Unlink (remove) a named semaphore.
;1004 //
;1005 //  If an active, named semaphore with the specified name exists, and there
;1006 //  are no open connections to it, it is released/destroyed (i.e. made
;1007 //  available for use by another sem_open() call).
;1008 //
;1009 //  If it exists, but has open connections, then it is marked as unlinked a
;1010 //  it is not accessible via any sem_xxx() functions except sem_post() and
;1011 //  sem_close().
;1012 //
;1013 //  Once all open connections to an unlinked semaphore are closed, the
;1014 //  semaphore is released/destroyed.
;1015 //-------------------------------------------------------------------------
;1016 int sem_unlink(const char *name)
;1017 {
$sem_unlink::
	.debug	G $sem_unlink 65 9
	.debug	{ $sem_unlink 65 1016 @285 @284
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A name 5 53
;1018   sem_t *sem;
	.debug	L sem -2 33
;1019 
;1020 
;1021   KLOCK();
	.debug	# 1021
	call	_KLOCK
;1022 
;1023   sem = getNamedSemaphore(name, NULL);
	.debug	# 1023
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$getNamedSemaphore
	add	sp,4
	ld	(ix-2),hl
;1024 
;1025   if (!sem)  { KUNLOCK();  errno = ENOENT;  return -1; }
	.debug	# 1025
	bool	hl
	jr	nz,@286
@287:
	.debug	< @287 @288
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x2
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@284
@288:
	.debug	>
;1026 
;1027   sem->unlinked = true;  semFreeIfNotOpen(sem);
@286:
	.debug	# 1027
	ld	hl,(ix-2)
	ld	de,0x10
	add	hl,de
	ld	a,0x1
	ld	(hl),a
	ld	hl,(ix-2)
	push	hl
	lcall	$semFreeIfNotOpen
	pop	hl
;1028 
;1029   KUNLOCK();
	.debug	# 1029
	call	_KUNLOCK
;1030 
;1031   return -1;
	.debug	# 1031
	ld	hl,0xffff
;1032 }
@284:
	.debug	} @284 1032

@283	equ	2
	ld	sp,ix
	pop	ix
	lret
@285	equ	4
;1033 
;1034 
;1035 //-------------------------------------------------------------------------
;1036 
	.extern	_memset 66
	.extern	_strlen 65
	.extern	_fstrcmp 68
	.extern	_fstrcpy 69
	.extern	$ValidatePtr 70
	.extern	$init_waitqueue_head 71
	.extern	$__add_wait_queue_tail 72
	.extern	$__removeWaitQueue 73
	.extern	$alloc_WaitQueueNode 74
	.extern	$free_WaitQueueNode 48
	.extern	_current 43
	.extern	$schedule_timeout 75
	.extern	$fprintf 76
	.extern	_KLOCK 49
	.extern	_KUNLOCK 49
	.extern	_diagLog 77
	.extern	_dataStart 7
	.extern	_dataEnd 7
	.extern	_bssStart 7
	.extern	_bssEnd 7
	.extern	$msToTicks 78
	.extern	$gettimeofday 79
	.bseg
_semaphores:
	.ds	352
	.debug	F _semaphores 80 0
	.defseg	FARBSS
	.seg	FARBSS
_names:
	.ds	384
	.debug	F _names 81 8
	.cseg
_semRemovedFromOpenList:
	pop	iy
	lcall	$$semRemovedFromOpenList
_semRemovedFromLockedList:
	pop	iy
	lcall	$$semRemovedFromLockedList
	.debug	T	0B000220000100030021000000
	.debug	T	070000210002002200
	.debug	T	680003220016000800010053000000056E616D650025000400076F
	.debug	T	70656E65640025000800076C6F636B65640025000C0008626C
	.debug	T	6F636B6564000300100009756E6C696E6B6564000300110006
	.debug	T	696E55736500060012000676616C75650043001400076D7941
	.debug	T	64647200
	.debug	T	0B000223000100060024000000
	.debug	T	070000240002002500
	.debug	T	280003250004000100125F5F776169745F71756575655F68656164
	.debug	T	0027000000096C6973744865616400
	.debug	T	070000260002002700
	.debug	T	2600032700040002000A6C6973745F686561640026000000056E65
	.debug	T	78740026000200057072657600
	.debug	T	0F0002280002002900240000002B000200
	.debug	T	070000290002002A00
	.debug	T	7100032A0012000700125F5F776169745F71756575655F6E6F6465
	.debug	T	000700000006666C616773002B000200057461736B00430004
	.debug	T	00046F626A00540006000B72656D6F766546756E6300270008
	.debug	T	00097461736B4C6973740027000C000A71756575654C697374
	.debug	T	0043001000076D794164647200
	.debug	T	0700002B0002002C00
	.debug	T	7702032C00E8002D000C7461736B5F737472756374003300000006
	.debug	T	737461636B00330002000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C68720055000F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465002B00150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	0005617267630057001A0005617267760058001C0005617267
	.debug	T	730025009C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C616773005900B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74005300D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	0F00022D00020003002400000029000200
	.debug	T	0F00022E0002000100210000002B000200
	.debug	T	0B00022F000100010021000000
	.debug	T	0B000230000100010029000000
	.debug	T	0B000231000100010001000000
	.debug	T	0B000232000100070033000000
	.debug	T	070000330002000700
	.debug	T	0F00023400020021003500000036000200
	.debug	T	070000350002000300
	.debug	T	070000360002002100
	.debug	T	17000237000400210035000000060002000900040007000800
	.debug	T	130002380003000600210000000600020007000400
	.debug	T	0B000239000100060021000000
	.debug	T	0F00023A00020006002100000009000200
	.debug	T	0F00023B0002000600210000003C000200
	.debug	T	0700003C0002003D00
	.debug	T	2A00033D00080002000974696D657370656300090000000774765F
	.debug	T	73656300080004000874765F6E73656300
	.debug	T	2900033E00080002000874696D6576616C00090000000774765F73
	.debug	T	656300080004000874765F7573656300
	.debug	T	0F00023F00020006002100000040000200
	.debug	T	070000400002000600
	.debug	T	0B000241000100060035000000
	.debug	T	130002420003004300430000000600020007000400
	.debug	T	070000430002000100
	.debug	T	0F00024400020006005300000053000400
	.debug	T	0F00024500020001005300000053000400
	.debug	T	17000246000400060043000000430002003500040035000600
	.debug	T	0B000247000100010024000000
	.debug	T	0F00024800020001002400000029000200
	.debug	T	0F00024900020006002400000029000200
	.debug	T	0B00024A000100290001000000
	.debug	T	0B00024B000100080008000000
	.debug	T	1300024C00030006005B000000350002000D000000
	.debug	T	5400034D000C00060001005C000000065F5F6F7574005E00020005
	.debug	T	5F5F696E0060000400085F5F77726974650060000600075F5F
	.debug	T	726561640006000800085F5F756E6765740043000A000B5F5F
	.debug	T	757365724461746100
	.debug	T	0B00024E000100090009000000
	.debug	T	0F00024F00020006006200000043000200
	.debug	T	0900015000600122001000
	.debug	T	0900015100800152001000
	.debug	T	0900015200180003001800
	.debug	T	070008530004000300
	.debug	T	070000540002003000
	.debug	T	070000550002005600
	.debug	T	070008560004000100
	.debug	T	070000570002003500
	.debug	T	0900015800800003008000
	.debug	T	070000590002005A00
	.debug	T	0F00025A00020001000600000057000200
	.debug	T	0700005B0002004D00
	.debug	T	0700005C0002005D00
	.debug	T	0F00025D00020006000300000043000200
	.debug	T	0700005E0002005F00
	.debug	T	0B00025F000100060043000000
	.debug	T	070000600002006100
	.debug	T	130002610003000800530000000800040043000800
	.debug	T	070000620002003E00
	.defseg	CONST
	.seg	CONST
@4:
	.db	"namedSemaphore",0,"sem_t",0,"unnamedSemaphore",0,"blocked tasks",0,"*** %s on fully closed, unlinked "
	.db	"semaphore ***",10,0,"locks",0,"semRemovedFromLockedList",0,"getNamedSemaphore",0,"***** sem_init() on i"
	.db	"nUse semaphore! *****",10,0,"sem_wait_",0,"sem_getvalue",0
	.end
