	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\kernel\signal.c' 1 29 13 3 8 29
;1 //----- signal.c ----- 08/03/09 -----(04/30/07)-----
;2 
;3 //=========================================================================
;4 //  sigsetops(3) functions that allow the manipulation of POSIX signal sets
;5 //=========================================================================
;6 // NOTES
;7 //
;8 //   Signal handling in DEBROS is currently limited to setting which signal
;9 //   are blocked (or not).  Setting a signal handler is not yet implemented
;10 //   so the only real use for this is to allow a process to block a signal
;11 //   giving it the chance to periodically check for pending signals and the
;12 //   deal with them within the normal program flow.
;13 //
;14 //   For example, simply killing all processes to do a shutdown doesn't giv
;15 //   processes a chance to clean up after themselves in an orderly manner.
;16 //
;17 //   To this end, each process will receive a terminate signal (SIGTERM)
;18 //   several seconds before actually being killed.  This will cause all
;19 //   blocked processes to be resumed with errno set to EINTR (interrupted
;20 //   system call).
;21 //
;22 //   To exit cleanly, processes must check for errors and call sigpending()
;23 //   to see if they have received a SIGTERM signal and then do what is need
;24 //   to exit cleanly on their own.  If they fail to do so within a few seco
;25 //   after receiving the SIGTERM signal, they will be killed and any files
;26 //   they had opened will be closed.
;27 //
;28 //   Example:
;29 //    sigset_t  sigSet;
;30 //
;31 //    // block Terminate signal so we can shut down cleanly if needed
;32 //    sigSet = sigmask(SIGTERM);  sigprocmask(SIG_BLOCK, &sigSet, NULL);
;33 //
;34 //    for (;;)  {
;35 //      ...
;36 //      // check for pending Terminate signal
;37 //      if (sigpending(&sigSet) == 0)  if (sigismember(&sigSet, SIGTERM))  
;38 //        ...;
;39 //        Exit(0);
;40 //      }
;41 //    }
;42 //
;43 //=========================================================================
;44 //
;45 //
;46 //  2009-08-03 - Mark Davis
;47 //               - sigprocmask now ignores SIGKILL and SIGSTOP bits rather
;48 //                 than returning -1 if either one is set.
;49 //
;50 //  2007-04-30 - Mark Davis
;51 //               - original version
;52 //
;53 //=========================================================================
;54 
;55 #include <common.h>
;56 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
	.debug	I
;57 #include <linux/sched.h>
;58 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I
;59 #include <sys/types.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
;60 #include <errno.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\errno.h' 22 0 10 11 8 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	# 109
_LIN2SEG	.macro

	.debug	# 110
add hl,hl

	.debug	# 111
rla

	.debug	# 112
add hl,hl

	.debug	# 113
rla

	.debug	# 114
add hl,hl

	.debug	# 115
rla

	.debug	# 116
add hl,hl

	.debug	# 117
rla

	.debug	# 118
sub 0x0E

	.debug	# 119
or a

	.debug	# 120
rr hl

	.debug	# 121
scf

	.debug	# 122
rr hl

	.debug	# 123
scf

	.debug	# 124
rr hl

	.debug	# 125
scf

	.debug	# 126
rr hl

	.debug	# 127
.endm

	.cseg
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
	.debug	I
	.debug	I
	.debug	I
	.debug	I
;61 #include <unistd.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
;62 #include <fcntl.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I
;63 #include <sys/stat.h>
;64 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\stat.h' 0 48 10 31 3 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I
;65 #include <signal.h>
;66 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
;67 
;68 #define UnblockableSet  ( sigmask(SIGKILL) | sigmask(SIGSTOP) )
;69 
;70 //-------------------------------------------------------------------------
;71 //  initialize the signal set given by set to empty, with all signals exclu
;72 //  from the set.
;73 //-------------------------------------------------------------------------
;74 int sigemptyset(sigset_t *set)
;75 {
	.defseg	FARCODE
	.seg	FARCODE
$sigemptyset::
	.debug	G $sigemptyset 32 9
	.debug	{ $sigemptyset 32 74 @3 @2
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A set 5 33
;76   *set = 0;  return 0;
	.debug	# 76
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	bool	hl
	ld	l,h
;77 }
@2:
	.debug	} @2 77

@1	equ	0
	pop	ix
	lret
@3	equ	2
;78 
;79 //-------------------------------------------------------------------------
;80 //  initialize set to full, including all signals
;81 //-------------------------------------------------------------------------
;82 int sigfillset(sigset_t *set)
;83 {
$sigfillset::
	.debug	G $sigfillset 32 9
	.debug	{ $sigfillset 32 82 @6 @5
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A set 5 33
;84   *set = 0xfffffffUL;  return 0;
	.debug	# 84
	ld	de,0xffff
	ld	bc,0xfff
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	bool	hl
	ld	l,h
;85 }
@5:
	.debug	} @5 85

@4	equ	0
	pop	ix
	lret
@6	equ	2
;86 
;87 //-------------------------------------------------------------------------
;88 //  add signal signum to a set of signals
;89 //-------------------------------------------------------------------------
;90 int sigaddset(sigset_t *set, int signum)
;91 {
$sigaddset::
	.debug	G $sigaddset 34 9
	.debug	{ $sigaddset 34 90 @9 @8
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A set 5 33
	.debug	A signum 7 6
;92   if ((signum < 0) OR (signum > 31))  return -1;
	.debug	# 92
	ld	hl,(ix+7)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@10
	ld	hl,(ix+7)
	ld	e,0x1f
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@11
	jr	z,@11
@10:
	ld	hl,0xffff
	jr	@8
;93 
;94   *set |= sigmask(signum);  return 0;
@11:
	.debug	# 94
	ld	hl,(ix+7)
	dec	hl
	ld	a,l
	ld	de,0x1
	ld	c,d
	ld	b,d
	call	__lshl##
	ld	hl,(ix+5)
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lor##
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	bool	hl
	ld	l,h
;95 }
@8:
	.debug	} @8 95

@7	equ	0
	pop	ix
	lret
@9	equ	2
;96 
;97 //-------------------------------------------------------------------------
;98 //  delete signal signum from a set of signals
;99 //-------------------------------------------------------------------------
;100 int sigdelset(sigset_t *set, int signum)
;101 {
$sigdelset::
	.debug	G $sigdelset 34 9
	.debug	{ $sigdelset 34 100 @14 @13
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A set 5 33
	.debug	A signum 7 6
;102   if ((signum < 0) OR (signum > 31))  return -1;
	.debug	# 102
	ld	hl,(ix+7)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@15
	ld	hl,(ix+7)
	ld	e,0x1f
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@16
	jr	z,@16
@15:
	ld	hl,0xffff
	jr	@13
;103 
;104   *set &= ~sigmask(signum);  return 0;
@16:
	.debug	# 104
	ld	hl,(ix+7)
	dec	hl
	ld	a,l
	ld	de,0x1
	ld	c,d
	ld	b,d
	call	__lshl##
	call	__lnot##
	ld	hl,(ix+5)
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__land##
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	bool	hl
	ld	l,h
;105 }
@13:
	.debug	} @13 105

@12	equ	0
	pop	ix
	lret
@14	equ	2
;106 
;107 //-------------------------------------------------------------------------
;108 //  test whether signum is a member of a signal set
;109 //-------------------------------------------------------------------------
;110 int sigismember(const sigset_t *set, int signum)
;111 {
$sigismember::
	.debug	G $sigismember 34 9
	.debug	{ $sigismember 34 110 @19 @18
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A set 5 33
	.debug	A signum 7 6
;112   if ((signum < 0) OR (signum > 31))  return -1;
	.debug	# 112
	ld	hl,(ix+7)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@20
	ld	hl,(ix+7)
	ld	e,0x1f
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@21
	jr	z,@21
@20:
	ld	hl,0xffff
	jr	@18
;113 
;114   if (*set & sigmask(signum))  return 1;
@21:
	.debug	# 114
	ld	hl,(ix+7)
	dec	hl
	ld	a,l
	ld	de,0x1
	ld	c,d
	ld	b,d
	call	__lshl##
	ld	hl,(ix+5)
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@22
	ld	hl,0x1
	jr	@18
;115 
;116   return 0;
@22:
	.debug	# 116
	bool	hl
	ld	l,h
;117 }
@18:
	.debug	} @18 117

@17	equ	0
	pop	ix
	lret
@19	equ	2
;118 
;119 
;120 //-------------------------------------------------------------------------
;121 //  install a new signal handler for the signal with number signum
;122 //-------------------------------------------------------------------------
;123 sighandler_t signal(int signum, sighandler_t handler)
;124 {
$signal::
	.debug	G $signal 35 9
	.debug	{ $signal 35 123 @25 @24
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A signum 5 6
	.debug	A handler 7 36
;125   //finish
;126 
;127   return (sighandler_t) 0;
	.debug	# 127
	bool	hl
	ld	l,h
;128 }
@24:
	.debug	} @24 128

@23	equ	0
	pop	ix
	lret
@25	equ	2
;129 
;130 //-------------------------------------------------------------------------
;131 //  change the action taken by a process on receipt of a specific signal
;132 //-------------------------------------------------------------------------
;133 int sigaction(int signum, const struct sigaction *act,
;134               struct sigaction *oldact)
;135 {
$sigaction::
	.debug	G $sigaction 38 9
	.debug	{ $sigaction 38 133 @28 @27
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A signum 5 6
	.debug	A act 7 39
	.debug	A oldact 9 39
;136 //finish
;137 
;138   return -1;
	.debug	# 138
	ld	hl,0xffff
;139 }
@27:
	.debug	} @27 139

@26	equ	0
	pop	ix
	lret
@28	equ	2
;140 
;141 //-------------------------------------------------------------------------
;142 //  change the set of currently blocked signals
;143 //-------------------------------------------------------------------------
;144 int sigprocmask(int how, const sigset_t *newSet, sigset_t *oldSet)
;145 {
$sigprocmask::
	.debug	G $sigprocmask 41 9
	.debug	{ $sigprocmask 41 144 @31 @30
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A how 5 6
	.debug	A newSet 7 33
	.debug	A oldSet 9 33
;146   KLOCK();
	.debug	# 146
	call	_KLOCK
;147 
;148   if (oldSet)  *oldSet = current->sig_blocked;
	.debug	# 148
	ld	hl,(ix+9)
	bool	hl
	jr	z,@32
	ld	hl,(_current)
	ld	de,0xa4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;149 
;150   switch (how)  {
@32:
	.debug	# 150
	ld	hl,(ix+5)
	jr	@33
;151 
;152     case SIG_BLOCK:
@35:
	.debug	< @35 @36
;153       current->sig_blocked |= (*newSet & ~UnblockableSet);
	.debug	# 153
@37:
	ld	hl,(ix+7)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	res	0,d
	res	2,c
	ld	hl,(_current)
	push	bc
	push	de
	ld	de,0xa4
	add	hl,de
	pop	iy
	pop	af
	push	hl
	push	af
	push	iy
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lor##
	jr	@47
;154       break;
	.debug	# 154
;155 
;156     case SIG_UNBLOCK:
;157       current->sig_blocked &= ~(*newSet);
	.debug	# 157
@38:
	ld	hl,(ix+7)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lnot##
	ld	hl,(_current)
	push	bc
	push	de
	ld	de,0xa4
	add	hl,de
	pop	iy
	pop	af
	push	hl
	push	af
	push	iy
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__land##
@47:
	pop	hl
	jr	@46
;158       break;
	.debug	# 158
;159 
;160     default:
;161       current->sig_blocked = *newSet;
	.debug	# 161
@39:
	ld	hl,(ix+7)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(_current)
	push	de
	ld	de,0xa4
	add	hl,de
	pop	de
@46:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;162   }
@36:
	.debug	>
;163 
;164   KUNLOCK();
	jr	@34
@33:
	ex	de,hl
	ld	hl,0xffffffff
	add	hl,de
	bool	hl
	jr	z,@37
	ld	hl,0xfffffffe
	add	hl,de
	bool	hl
	jr	z,@38
	jr	@39
@34:
	.debug	# 164
	call	_KUNLOCK
;165 
;166   return 0;
	.debug	# 166
	bool	hl
	ld	l,h
;167 }
@30:
	.debug	} @30 167

@29	equ	0
	pop	ix
	lret
@31	equ	2
;168 
;169 //-------------------------------------------------------------------------
;170 //  get the mask/set of pending signals
;171 //-------------------------------------------------------------------------
;172 int sigpending(sigset_t *set)
;173 {
$sigpending::
	.debug	G $sigpending 32 9
	.debug	{ $sigpending 32 172 @42 @41
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A set 5 33
;174   *set = current->sig_pending;
	.debug	# 174
	ld	hl,(_current)
	ld	de,0xa0
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;175 
;176   return 0;
	.debug	# 176
	bool	hl
	ld	l,h
;177 }
@41:
	.debug	} @41 177

@40	equ	0
	pop	ix
	lret
@42	equ	2
;178 
;179 
;180 
;181 //-------------------------------------------------------------------------
;182 //  temporarily replace the signal mask for the process with that given by
;183 //  mask and then suspend the process until a signal is received
;184 //-------------------------------------------------------------------------
;185 int sigsuspend(const sigset_t *mask)
;186 {
$sigsuspend::
	.debug	G $sigsuspend 32 9
	.debug	{ $sigsuspend 32 185 @45 @44
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A mask 5 33
;187 //finish
;188 
;189   return -1;
	.debug	# 189
	ld	hl,0xffff
;190 }
@44:
	.debug	} @44 190

@43	equ	0
	pop	ix
	lret
@45	equ	2
;191 
;192 
;193 
;194 //-------------------------------------------------------------------------
;195 
	.extern	_current 42
	.extern	_KLOCK 44
	.extern	_KUNLOCK 44
	.debug	T	0B000220000100060021000000
	.debug	T	070000210002000900
	.debug	T	0F00022200020006002100000006000200
	.debug	T	0F00022300020024000600000024000200
	.debug	T	070000240002002500
	.debug	T	0B000225000100010006000000
	.debug	T	130002260003000600060000002700020027000400
	.debug	T	070000270002002800
	.debug	T	4E000328000C0004000A736967616374696F6E00240000000B7361
	.debug	T	5F68616E646C657200090002000973615F666C616773002D00
	.debug	T	06000C73615F726573746F72657200090008000873615F6D61
	.debug	T	736B00
	.debug	T	130002290003000600060000002100020021000400
	.debug	T	0700002A0002002B00
	.debug	T	7702032B00E8002D000C7461736B5F737472756374002E00000006
	.debug	T	737461636B002E0002000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C6872002F000F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465002A00150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	0005617267630031001A0005617267760033001C0005617267
	.debug	T	730034009C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C616773003500B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74003700D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	0B00022C000100010001000000
	.debug	T	0700002D0002002C00
	.debug	T	0700002E0002000700
	.debug	T	0700002F0002003000
	.debug	T	070008300004000100
	.debug	T	070000310002003200
	.debug	T	070000320002000300
	.debug	T	0900013300800003008000
	.debug	T	280003340004000100125F5F776169745F71756575655F68656164
	.debug	T	0038000000096C6973744865616400
	.debug	T	070000350002003600
	.debug	T	0F00023600020001000600000031000200
	.debug	T	070008370004000300
	.debug	T	2600033800040002000A6C6973745F686561640039000000056E65
	.debug	T	78740039000200057072657600
	.debug	T	070000390002003800
	.end
