@rem --- path_.bat --- 09/13/07 ---(01/08/07)---
@echo off

rem ---------------------------------------------------------------------------
rem  -- Script to display the search path in a readable format ---
rem ---------------------------------------------------------------------------
rem
rem  2007-01-08 - Mark Davis - original version
rem
rem ---------------------------------------------------------------------------

  setlocal ENABLEDELAYEDEXPANSION

rem --- need to convert PATH to a space-delimited list of dirs, but the ---
rem --- dir names can have spaces in them, so this is handled by doing this:
rem     change " "s to "/"s (since "/"s will never be in DOS/Window dir names)
rem     change ";"s to " "s,
rem     use "for" cmd to iterate through now space-delimited list
rem     changing "/"s back to " "s as each entry is displayed
  echo.
  set paths=%PATH: =/%
  set paths=%paths:;= %
  for %%p in (%paths%) do set dir=%%p  &&  echo   !dir:/= !
