//----- cat.c ----- 05/08/09 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2009-05-08 - Mark Davis
//               - Added call to CheckETX() so the command can be interrupted
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <applic.h>

#include <sys/farprintf.h>


//-----------------------------------------------------------------------------
//  copy file to stdout
//-----------------------------------------------------------------------------
void _task _cat(int argc, char **argv)
{
  int  stat;
  fd_t  fd;
  char  buf[256];


  if (showHelp(1, argc, argv))  {
    printf("\nusage:  cat [file]\r\n");  Exit(-1); }

  if (argc < 2)
    fd = 0;
  else
    if ((fd = open(argv[1], O_RDONLY, 0)) < 0)  { perror(argv[1]);  Exit(-1); }

  while ((stat = read(fd, buf, sizeof(buf))) > 0)  {
    write(1, buf, stat);  CheckETX();  }

  close(fd);  Exit(0);
}

//-----------------------------------------------------------------------------
