//----- mv.c ----- 03/31/09 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <tsh.h>

#include <applic.h>

#include <sys/farprintf.h>

//-----------------------------------------------------------------------------
//  move (rename) a file
//-----------------------------------------------------------------------------
void _task _mv(int argc, char **argv)
{
  if (showHelp(3, argc, argv))  {
    printf("\nusage: mv old new\r\n");  Exit(-1); }

  if (rename(argv[1], argv[2]))  { perror("rename()");  Exit(-1); }

  Exit(0);
}

//-----------------------------------------------------------------------------
